package com.Ostermiller.util;

import java.io.*;

class BrowserCommandLexer
{

    private static void main(String args[])
    {
        try
        {
            Object obj;
            if(args.length > 0)
            {
                File file = new File(args[0]);
                if(file.exists())
                {
                    if(file.canRead())
                        obj = new FileInputStream(file);
                    else
                        throw new IOException("Could not open " + args[0]);
                } else
                {
                    throw new IOException("Could not find " + args[0]);
                }
            } else
            {
                obj = System.in;
            }
            BrowserCommandLexer browsercommandlexer = new BrowserCommandLexer(((InputStream) (obj)));
            String s;
            while((s = browsercommandlexer.getNextToken()) != null)
                System.out.println(s);
        }
        catch(IOException ioexception)
        {
            System.out.println(ioexception.getMessage());
        }
    }

    private static String unescape(String s)
    {
        StringBuffer stringbuffer = new StringBuffer(s.length());
        for(int i = 0; i < s.length(); i++)
        {
            if(s.charAt(i) == '\\' && i < s.length())
                i++;
            stringbuffer.append(s.charAt(i));
        }

        return stringbuffer.toString();
    }

    BrowserCommandLexer(Reader reader)
    {
        yycmap_instance = yycmap;
        yy_lexical_state = 0;
        yy_buffer = new char[16384];
        yy_reader = reader;
    }

    BrowserCommandLexer(InputStream inputstream)
    {
        this(((Reader) (new InputStreamReader(inputstream))));
    }

    private static int[] yy_unpack()
    {
        int ai[] = new int[36];
        int i = 0;
        i = yy_unpack("\001\002\001\003\001\004\001\005\001\002\001\006\001\000\005\002\004\000\001\005\001\007\001\b\001\t\001\005\001\n\001\005\001\013\001\b\001\f\001\b\001\r\001\005\001\007\001\b\001\013\001\b\001\f\001\b\001\016", i, ai);
        return ai;
    }

    private static int yy_unpack(String s, int i, int ai[])
    {
        int j = 0;
        int k = i;
        for(int l = s.length(); j < l;)
        {
            int i1 = s.charAt(j++);
            int j1 = s.charAt(j++);
            j1--;
            do
                ai[k++] = j1;
            while(--i1 > 0);
        }

        return k;
    }

    private static char[] yy_unpack_cmap(String s)
    {
        char ac[] = new char[0x10000];
        int i = 0;
        int j = 0;
        while(i < 26)
        {
            int k = s.charAt(i++);
            char c = s.charAt(i++);
            do
                ac[j++] = c;
            while(--k > 0);
        }
        return ac;
    }

    private boolean yy_refill()
        throws IOException
    {
        if(yy_startRead > 0)
        {
            System.arraycopy(yy_buffer, yy_startRead, yy_buffer, 0, yy_endRead - yy_startRead);
            yy_endRead -= yy_startRead;
            yy_currentPos -= yy_startRead;
            yy_markedPos -= yy_startRead;
            yy_pushbackPos -= yy_startRead;
            yy_startRead = 0;
        }
        if(yy_currentPos >= yy_buffer.length)
        {
            char ac[] = new char[yy_currentPos * 2];
            System.arraycopy(yy_buffer, 0, ac, 0, yy_buffer.length);
            yy_buffer = ac;
        }
        int i = yy_reader.read(yy_buffer, yy_endRead, yy_buffer.length - yy_endRead);
        if(i < 0)
        {
            return true;
        } else
        {
            yy_endRead += i;
            return false;
        }
    }

    private final void yybegin(int i)
    {
        yy_lexical_state = i;
    }

    private final String yytext()
    {
        return new String(yy_buffer, yy_startRead, yy_markedPos - yy_startRead);
    }

    private final int yylength()
    {
        return yy_markedPos - yy_startRead;
    }

    private void yy_ScanError(int i)
    {
        String s;
        try
        {
            s = YY_ERROR_MSG[i];
        }
        catch(ArrayIndexOutOfBoundsException arrayindexoutofboundsexception)
        {
            s = YY_ERROR_MSG[0];
        }
        throw new Error(s);
    }

    private void yypushback(int i)
    {
        if(i > yylength())
            yy_ScanError(3);
        yy_markedPos -= i;
    }

    public String getNextToken()
        throws IOException
    {
        int i1 = yy_endRead;
        char ac[] = yy_buffer;
        char ac1[] = yycmap_instance;
        int ai[] = yytrans;
        int ai1[] = yy_rowMap;
        byte abyte0[] = YY_ATTRIBUTE;
        do
        {
            int l = yy_markedPos;
            int i = -1;
            int j;
            int k = j = yy_currentPos = yy_startRead = l;
            yy_state = yy_lexical_state;
            char c;
            byte byte0;
label0:
            do
            {
                do
                {
                    if(j < i1)
                    {
                        c = ac[j++];
                    } else
                    {
                        if(yy_atEOF)
                        {
                            c = '\uFFFF';
                            break label0;
                        }
                        yy_currentPos = j;
                        yy_markedPos = l;
                        boolean flag = yy_refill();
                        j = yy_currentPos;
                        l = yy_markedPos;
                        ac = yy_buffer;
                        i1 = yy_endRead;
                        if(flag)
                        {
                            c = '\uFFFF';
                            break label0;
                        }
                        c = ac[j++];
                    }
                    int j1 = ai[ai1[yy_state] + ac1[c]];
                    if(j1 == -1)
                        break label0;
                    yy_state = j1;
                    byte0 = abyte0[yy_state];
                } while((byte0 & 1) != 1);
                i = yy_state;
                l = j;
            } while((byte0 & 8) != 8);
            yy_markedPos = l;
            switch(i)
            {
            case 0: // '\0'
            case 1: // '\001'
            case 4: // '\004'
            case 9: // '\t'
                return unescape(yytext());

            case 8: // '\b'
            case 10: // '\n'
            case 12: // '\f'
            case 13: // '\r'
                return unescape(yytext().substring(1, yytext().length() - 1));

            case 5: // '\005'
            case 6: // '\006'
            case 7: // '\007'
            case 11: // '\013'
            case 14: // '\016'
            default:
                if(c == '\uFFFF' && yy_startRead == yy_currentPos)
                {
                    yy_atEOF = true;
                    return null;
                }
                yy_ScanError(2);
                break;

            case 2: // '\002'
            case 3: // '\003'
            case 15: // '\017'
            case 16: // '\020'
            case 17: // '\021'
                break;
            }
        } while(true);
    }

    private static final int YYEOF = -1;
    private static final int YY_BUFFERSIZE = 16384;
    public static final int YYINITIAL = 0;
    private static final String yycmap_packed = "\t\000\002\002\001\000\002\002\022\000\001\002\001\000\001\003\036\000\001\000\032\000\001\001\uFFA3\0";
    private static final char yycmap[] = yy_unpack_cmap("\t\000\002\002\001\000\002\002\022\000\001\002\001\000\001\003\036\000\001\000\032\000\001\001\uFFA3\0");
    private static final int yy_rowMap[] = {
        0, 4, 8, 12, 16, 8, 20, 24, 4, 28,
        16, 32, 12, 24
    };
    private static final String yy_packed0 = "\001\002\001\003\001\004\001\005\001\002\001\006\001\000\005\002\004\000\001\005\001\007\001\b\001\t\001\005\001\n\001\005\001\013\001\b\001\f\001\b\001\r\001\005\001\007\001\b\001\013\001\b\001\f\001\b\001\016";
    private static final int yytrans[] = yy_unpack();
    private char yycmap_instance[];
    private static final int YY_UNKNOWN_ERROR = 0;
    private static final int YY_ILLEGAL_STATE = 1;
    private static final int YY_NO_MATCH = 2;
    private static final int YY_PUSHBACK_2BIG = 3;
    private static final String YY_ERROR_MSG[] = {
        "Unkown internal scanner error", "Internal error: unknown state", "Error: could not match input", "Error: pushback value was too large"
    };
    private static final byte YY_ATTRIBUTE[] = {
        1, 1, 1, 9, 1, 0, 0, 0, 1, 1,
        1, 0, 9, 1
    };
    private Reader yy_reader;
    private int yy_state;
    private int yy_lexical_state;
    private char yy_buffer[];
    private int yy_markedPos;
    private int yy_pushbackPos;
    private int yy_currentPos;
    private int yy_startRead;
    private int yy_endRead;
    private boolean yy_atEOF;

}
