/******************************************************************************
 *
 * Numerical Chameleon version 1.6.0 - conversion tool
 * Copyright (C) 2001-2004  Dipl.-Inf. (FH) Johann Nepomuk Loefflmann,
 * All Rights Reserved, http://www.jonelo.de
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * e-Mail: jonelo@jonelo.de
 *
 *****************************************************************************/
package jonelo.NumericalChameleon.Bookmarks;

import jonelo.NumericalChameleon.*;
import java.util.*;
public class Bookmark {

    public final static String DELIM="##";

    private String
      language,
      country,
      description,
      category,
      sourceDescription,
      sourceCountry,
      targetDescription,
      targetCountry,
      value;

    /** Creates a new instance of Bookmark */
    public Bookmark(SectionRecord sectionRecord, NcRecord sourceRecord, NcRecord targetRecord) {
        language="en";
        country="US";

        category = (((SectionRecord)sectionRecord).getName());
        sourceDescription = (((NcRecord)sourceRecord).getString());
        sourceCountry =  (((NcRecord)sourceRecord).getIcon());
        targetDescription = (((NcRecord)targetRecord).getString());
        targetCountry = (((NcRecord)targetRecord).getIcon());

        description=sourceDescription+" -> "+targetDescription;
        value="";
    }

    public Bookmark(String string) {
       StringTokenizer st = new StringTokenizer(string,DELIM);
       language=st.nextToken();
       country=st.nextToken();
       description=st.nextToken();
       category=st.nextToken();
       sourceDescription=st.nextToken();
       sourceCountry=st.nextToken();
       targetDescription=st.nextToken();
       targetCountry=st.nextToken();
       if (st.hasMoreTokens()) value=st.nextToken(); else value="";
    }

    public String toString() {
        return description;
    }

    public String getBookmarkAsString() {
        return language+DELIM+country+DELIM+
        description+DELIM+category+DELIM+
        sourceDescription+DELIM+sourceCountry+DELIM+
        targetDescription+DELIM+targetCountry+DELIM+value;
    }

    public String getDescription() {
        return description;
    }

    public String getCategory() {
        return category;
    }

    public String getSourceDescription() {
        return sourceDescription;
    }

    public String getSourceCountry() {
        return sourceCountry;
    }

    public String getTargetDescription() {
        return targetDescription;
    }

    public String getTargetCountry() {
        return targetCountry;
    }

    public void setDescription(String description) {
        this.description=description;
    }

    public void setLanguage(String language) {
        this.language=language;
    }

    public String getLanguage() {
        return language;
    }

    public void setCountry(String country) {
        this.country=country;
    }

    public String getCountry() {
        return country;
    }

    public void setValue(String value) {
        this.value=value;
    }

    public String getValue() {
        return value;
    }

}
