/******************************************************************************
 *
 * Numerical Chameleon version 1.6.0 - conversion tool
 * Copyright (C) 2001-2004  Dipl.-Inf. (FH) Johann Nepomuk Loefflmann,
 * All Rights Reserved, http://www.jonelo.de
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * e-Mail: jonelo@jonelo.de
 *
 *****************************************************************************/

package jonelo.NumericalChameleon.Bookmarks;
import java.util.*;
import java.io.*;
import javax.swing.*;

public class Bookmarks extends DefaultListModel {

//    private Vector bookmarks;
    private String filename;

    /** Creates a new instance of Bookmarks */
    public Bookmarks(String filename)  {
        super();
        this.filename=filename;
        //bookmarks = new Vector();
    }
/*
    public Vector getVector() {
        return bookmarks;
    }

    public Bookmark get(int index) {
        return (Bookmark)bookmarks.get(index);
    }

    public void add(Bookmark bookmark) {
        bookmarks.add(bookmark);
    }

    public void remove(Bookmark bookmark) {
        bookmarks.remove(bookmark);
    }
*/
    public void save() throws IOException {

        FileOutputStream fos = null;
        OutputStreamWriter osw = null;
        BufferedWriter bw = null;

        try {
           fos = new FileOutputStream(filename);
           osw = new OutputStreamWriter(fos,"UnicodeBig");
           bw = new BufferedWriter(osw);
           String string;

           for (int i=0; i < size(); i++) {
               bw.write(((Bookmark)get(i)).getBookmarkAsString());
               bw.write("\n");
           }
        } finally {
           if (bw!=null) bw.close();
           if (osw!=null) osw.close();
           if (fos!=null) fos.close();
        }

    }

    public void read() throws IOException {
        clear();

        FileInputStream fis=null;
        InputStreamReader isr=null;
        BufferedReader br=null;
        try {
           fis = new FileInputStream(filename);
           isr = new InputStreamReader(fis,"UnicodeBig");
           br = new BufferedReader(isr);

           String string;
           while ((string = br.readLine()) != null) {
              add(getSize(),new Bookmark(string));
           }
        } finally {
           if (br!=null) br.close();
           if (isr!=null) isr.close();
           if (fis!=null) fis.close();
        }
    }

}
