/******************************************************************************
 *
 * Numerical Chameleon version 1.6.0 - conversion tool
 * Copyright (C) 2001-2004  Dipl.-Inf. (FH) Johann Nepomuk Loefflmann,
 * All Rights Reserved, http://www.jonelo.de
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * e-Mail: jonelo@jonelo.de
 *
 *****************************************************************************/
package jonelo.NumericalChameleon.Bookmarks;
import jonelo.NumericalChameleon.SectionRecord;
import jonelo.sugar.util.*;
import jonelo.sugar.gui.*;
import java.io.*;
import javax.swing.*;
import java.util.*;
import java.awt.*;

public class BookmarksDialog extends javax.swing.JDialog {

    /** Creates new form BookmarksDialog */
    Bookmarks bookmarks;
    Hashtable categoriesHashtable;
    ResourceBundle rb;
    public BookmarksDialog(java.awt.Frame parent, boolean modal, ResourceBundle rb, Bookmarks bookmarks, Hashtable categoriesHashtable) {
        super(parent, modal);
        if (GeneralProgram.isSupportFor("1.4") && parent.isUndecorated()) {
            setUndecorated(true);
            getRootPane().setWindowDecorationStyle(JRootPane.FRAME);
        }        
        setTitle(rb.getString("GUI.Menu.Favorites.Manage"));
        this.rb=rb;
        this.bookmarks=bookmarks;
        this.categoriesHashtable=categoriesHashtable;
        initComponents();
        countLabel.setText(GeneralString.message(rb.getString("GUI.Bookmarks.Favorites"),bookmarks.getSize()));
        bookmarksList.setModel(bookmarks);
        GeneralGUI.setLocationRelativeTo(this,parent);
        ComponentOrientation ce = ComponentOrientation.getOrientation(Locale.getDefault()); 
        if (!ce.isLeftToRight()) GeneralGUI.applyOrientation(bookmarkPanel, ce);  
        cancelButton.requestFocus();
        Boolean boo = new Boolean(true);
        show();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        java.awt.GridBagConstraints gridBagConstraints;

        bookmarkPanel = new javax.swing.JPanel();
        jPanel3 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        bookmarksList = new javax.swing.JList();
        jPanel5 = new javax.swing.JPanel();
        countLabel = new javax.swing.JLabel();
        jPanel4 = new javax.swing.JPanel();
        upButton = new javax.swing.JButton();
        downButton = new javax.swing.JButton();
        infoButton = new javax.swing.JButton();
        renameButton = new javax.swing.JButton();
        removeButton = new javax.swing.JButton();
        jPanel2 = new javax.swing.JPanel();
        restoreButton = new javax.swing.JButton();
        saveCloseButton = new javax.swing.JButton();
        cancelButton = new javax.swing.JButton();

        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });

        bookmarkPanel.setLayout(new java.awt.GridBagLayout());

        jPanel3.setLayout(new java.awt.BorderLayout());

        jPanel3.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(5, 5, 5, 5)));
        jPanel3.setMinimumSize(new java.awt.Dimension(300, 300));
        jPanel3.setPreferredSize(new java.awt.Dimension(300, 300));
        bookmarksList.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
        bookmarksList.setVisibleRowCount(12);
        bookmarksList.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                bookmarksListMouseClicked(evt);
            }
        });

        jScrollPane1.setViewportView(bookmarksList);

        jPanel3.add(jScrollPane1, java.awt.BorderLayout.CENTER);

        jPanel5.setLayout(new java.awt.BorderLayout());

        countLabel.setText("0 Favorites");
        jPanel5.add(countLabel, java.awt.BorderLayout.WEST);

        jPanel3.add(jPanel5, java.awt.BorderLayout.SOUTH);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        bookmarkPanel.add(jPanel3, gridBagConstraints);

        jPanel4.setLayout(new java.awt.GridBagLayout());

        jPanel4.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(5, 5, 5, 5)));
        upButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/core/images/main/up.png")));
        upButton.setText(rb.getString("GUI.Bookmarks.Up"));
        upButton.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        upButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                upButtonActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanel4.add(upButton, gridBagConstraints);

        downButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/core/images/main/down.png")));
        downButton.setText(rb.getString("GUI.Bookmarks.Down"));
        downButton.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        downButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                downButtonActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 20, 0);
        jPanel4.add(downButton, gridBagConstraints);

        infoButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/core/images/main/Information16.gif")));
        infoButton.setText(rb.getString("GUI.Bookmarks.Info"));
        infoButton.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        infoButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                infoButtonActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanel4.add(infoButton, gridBagConstraints);

        renameButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/core/images/main/editor.gif")));
        renameButton.setText(rb.getString("GUI.Bookmarks.Rename"));
        renameButton.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        renameButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                renameButtonActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanel4.add(renameButton, gridBagConstraints);

        removeButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/core/images/main/Delete16.gif")));
        removeButton.setText(rb.getString("GUI.Bookmarks.Remove"));
        removeButton.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        removeButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                removeButtonActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanel4.add(removeButton, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTH;
        bookmarkPanel.add(jPanel4, gridBagConstraints);

        getContentPane().add(bookmarkPanel, java.awt.BorderLayout.CENTER);

        jPanel2.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.RIGHT));

        restoreButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/core/images/main/Undo16.gif")));
        restoreButton.setText(rb.getString("GUI.General.Restore"));
        restoreButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                restoreButtonActionPerformed(evt);
            }
        });

        jPanel2.add(restoreButton);

        saveCloseButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/core/images/main/Save16.gif")));
        saveCloseButton.setText(rb.getString("GUI.Bookmarks.SaveAndClose"));
        saveCloseButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                saveCloseButtonActionPerformed(evt);
            }
        });

        jPanel2.add(saveCloseButton);

        cancelButton.setText(rb.getString("GUI.General.Cancel"));
        cancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelButtonActionPerformed(evt);
            }
        });

        jPanel2.add(cancelButton);

        getContentPane().add(jPanel2, java.awt.BorderLayout.SOUTH);

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-500)/2, (screenSize.height-350)/2, 500, 350);
    }//GEN-END:initComponents

    private void infoButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_infoButtonActionPerformed
        // Add your handling code here:
        if (!bookmarksList.isSelectionEmpty()) {
          int pos = bookmarksList.getSelectedIndex();
          Bookmark bookmark = (Bookmark)bookmarks.get(pos);
          BookmarkPanel bookmarkPanel = new BookmarkPanel(rb);
          fillPanel(bookmarkPanel, bookmark);
          JOptionPane.showMessageDialog(this,bookmarkPanel,"Info",JOptionPane.PLAIN_MESSAGE);
        }

    }//GEN-LAST:event_infoButtonActionPerformed

    private void bookmarksListMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_bookmarksListMouseClicked
        // Add your handling code here:
            if (evt.getClickCount() == 2) { // double-click
                renameButtonActionPerformed(null);
            }
    }//GEN-LAST:event_bookmarksListMouseClicked

    private void fillPanel(BookmarkPanel bookmarkPanel, Bookmark bookmark) {
         bookmarkPanel.getCategoryLabel().setIcon(new javax.swing.ImageIcon(getClass().getResource("/data/images/sections/"+bookmark.getCategory().toLowerCase()+".png")));
         bookmarkPanel.getCategoryLabel().setText(((SectionRecord)categoriesHashtable.get(bookmark.getCategory())).getString());
         bookmarkPanel.getSourceLabel().setText(bookmark.getSourceDescription());
         bookmarkPanel.getSourceLabel().setIcon(new javax.swing.ImageIcon(getClass().getResource("/data/images/flags/"+bookmark.getSourceCountry()+".png")));
         bookmarkPanel.getTargetLabel().setText(bookmark.getTargetDescription());
         bookmarkPanel.getTargetLabel().setIcon(new javax.swing.ImageIcon(getClass().getResource("/data/images/flags/"+bookmark.getTargetCountry()+".png")));
    }

    private void renameButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_renameButtonActionPerformed
        // Add your handling code here:

        if (!bookmarksList.isSelectionEmpty()) {
          String input = null;
          boolean end = false;
          int pos=bookmarksList.getSelectedIndex();
          Bookmark bookmark = (Bookmark)bookmarks.get(pos);
          BookmarkPanel bookmarkPanel = new BookmarkPanel(rb);
          fillPanel(bookmarkPanel, bookmark);

          while (!end) {
              if (GeneralProgram.isSupportFor("1.4"))
              input = JOptionPane.showInputDialog(this, bookmarkPanel, bookmark.getDescription());
              else
              input = JOptionPane.showInputDialog(this, bookmarkPanel);
              if (input!=null) { // it's not cancelled
                  if (!input.equals("") && input.indexOf(Bookmark.DELIM)==-1) { // delim not found, input is ok
                    bookmark.setDescription(input);
                    // let's trigger the JList by modifying the model
                    bookmarks.set(pos,bookmark);
                    end=true;
                  }
              } else end=true;
          }
        }
    }//GEN-LAST:event_renameButtonActionPerformed

    private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelButtonActionPerformed
        // Add your handling code here:
        restoreButtonActionPerformed(evt);
        closeDialog(null);
    }//GEN-LAST:event_cancelButtonActionPerformed

    private void saveCloseButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_saveCloseButtonActionPerformed
        // Add your handling code here:
        try {
          bookmarks.save();
        } catch (IOException ioe) {
            System.err.println(ioe);
        }
        closeDialog(null);
    }//GEN-LAST:event_saveCloseButtonActionPerformed

    private void restoreButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_restoreButtonActionPerformed
        // Add your handling code here:
        try {
          bookmarks.read();
          countLabel.setText(GeneralString.message(rb.getString("GUI.Bookmarks.Favorites"),bookmarks.getSize()));
        } catch (IOException ioe) {
            System.err.println(ioe);
        }
    }//GEN-LAST:event_restoreButtonActionPerformed

    private void downButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_downButtonActionPerformed
        // Add your handling code here:
        if (!bookmarksList.isSelectionEmpty()) {
          int pos = bookmarksList.getSelectedIndex();
          if (pos < bookmarks.getSize()-1) change(pos,pos+1);
        }
    }//GEN-LAST:event_downButtonActionPerformed

    private void removeButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_removeButtonActionPerformed
        // Add your handling code here:
        if (!bookmarksList.isSelectionEmpty()) {
          int pos = bookmarksList.getSelectedIndex();
          bookmarks.remove(pos);
          // it was the last item
          if (pos == bookmarks.getSize()) pos--;
          if (bookmarks.getSize() > 0) bookmarksList.setSelectedIndex(pos);
          countLabel.setText(GeneralString.message(rb.getString("GUI.Bookmarks.Favorites"),bookmarks.getSize()));
        }
    }//GEN-LAST:event_removeButtonActionPerformed

    private void upButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_upButtonActionPerformed
        // Add your handling code here:
        if (!bookmarksList.isSelectionEmpty()) {
          int pos = bookmarksList.getSelectedIndex();
          if (pos > 0) change(pos,pos-1);
        }
    }//GEN-LAST:event_upButtonActionPerformed

   private void change (int oldpos, int newpos) {
       Object backup=bookmarks.get(newpos);
       bookmarks.set(newpos, bookmarks.get(oldpos));
       bookmarks.set(oldpos, backup);
       bookmarksList.setSelectedIndex(newpos);
   }

    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        setVisible(false);
        dispose();
    }//GEN-LAST:event_closeDialog

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
       // new BookmarksDialog(new javax.swing.JFrame(), true).show();
    }


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel bookmarkPanel;
    private javax.swing.JList bookmarksList;
    private javax.swing.JButton cancelButton;
    private javax.swing.JLabel countLabel;
    private javax.swing.JButton downButton;
    private javax.swing.JButton infoButton;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JButton removeButton;
    private javax.swing.JButton renameButton;
    private javax.swing.JButton restoreButton;
    private javax.swing.JButton saveCloseButton;
    private javax.swing.JButton upButton;
    // End of variables declaration//GEN-END:variables

}
