/******************************************************************************
 *
 * Numerical Chameleon version 1.6.0 - conversion tool
 * Copyright (C) 2001-2004  Dipl.-Inf. (FH) Johann Nepomuk Loefflmann,
 * All Rights Reserved, http://www.jonelo.de
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * e-Mail: jonelo@jonelo.de
 *
 *****************************************************************************/
package jonelo.NumericalChameleon.CalendarChooser;

import java.util.Calendar;
import java.util.*;
import java.text.*;
import javax.swing.*;
import jonelo.sugar.gui.GeneralGUI;
import jonelo.sugar.util.GeneralProgram;


public class CalendarChooserDialog extends javax.swing.JDialog {

    private Calendar calendar;
    private ResourceBundle rb;
    private boolean[] status;

    /** Creates new form CalendarChooserDialog */
    public CalendarChooserDialog(java.awt.Frame parent, ResourceBundle rb, Calendar calendar, boolean[] status) {
        super(parent, true);
        this.calendar=calendar;
        this.rb=rb;
        this.status=status;
        if (GeneralProgram.isSupportFor("1.4") && parent.isUndecorated()) {
            setUndecorated(true);
            getRootPane().setWindowDecorationStyle(JRootPane.FRAME);
        }
        initComponents();
        GeneralGUI.setLocationRelativeTo(this,parent);
        show();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        java.awt.GridBagConstraints gridBagConstraints;

        calendarPanel = new javax.swing.JPanel();
        myCalendar = new com.toedter.calendar.JCalendar();
        labelPanel = new javax.swing.JPanel();
        dateLabel = new javax.swing.JLabel();
        buttonPanel = new javax.swing.JPanel();
        jPanel2 = new javax.swing.JPanel();
        todayButton = new javax.swing.JButton();
        weekOfYearButton = new javax.swing.JButton();
        jPanel3 = new javax.swing.JPanel();
        daysButton = new javax.swing.JButton();
        weeksButton = new javax.swing.JButton();
        jPanel1 = new javax.swing.JPanel();
        okButton = new javax.swing.JButton();
        cancelButton = new javax.swing.JButton();

        getContentPane().setLayout(new java.awt.GridBagLayout());

        setTitle(rb.getString("GUI.General.DatePicker"));
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });

        calendarPanel.setLayout(new java.awt.GridBagLayout());

        calendarPanel.setBorder(new javax.swing.border.BevelBorder(javax.swing.border.BevelBorder.RAISED));
        myCalendar.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
            public void propertyChange(java.beans.PropertyChangeEvent evt) {
                myCalendarPropertyChange(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        calendarPanel.add(myCalendar, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        getContentPane().add(calendarPanel, gridBagConstraints);

        labelPanel.setBorder(new javax.swing.border.TitledBorder(""));
        updateLabel((Calendar)myCalendar.getCalendar());
        labelPanel.add(dateLabel);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        getContentPane().add(labelPanel, gridBagConstraints);

        buttonPanel.setLayout(new java.awt.GridBagLayout());

        todayButton.setText(rb.getString("GUI.General.Today"));
        todayButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                todayButtonActionPerformed(evt);
            }
        });

        jPanel2.add(todayButton);

        weekOfYearButton.setText(rb.getString("Calendar.weekOfYear"));
        weekOfYearButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                weekOfYearButtonActionPerformed(evt);
            }
        });

        jPanel2.add(weekOfYearButton);

        buttonPanel.add(jPanel2, new java.awt.GridBagConstraints());

        daysButton.setText(rb.getString("Calendar.plusMinusDays"));
        daysButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                daysButtonActionPerformed(evt);
            }
        });

        jPanel3.add(daysButton);

        weeksButton.setText(rb.getString("Calendar.plusMinusWeeks"));
        weeksButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                weeksButtonActionPerformed(evt);
            }
        });

        jPanel3.add(weeksButton);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        buttonPanel.add(jPanel3, gridBagConstraints);

        okButton.setText("Ok");
        okButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                okButtonActionPerformed(evt);
            }
        });

        jPanel1.add(okButton);

        cancelButton.setText(rb.getString("GUI.General.Cancel"));
        cancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelButtonActionPerformed(evt);
            }
        });

        jPanel1.add(cancelButton);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        buttonPanel.add(jPanel1, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        getContentPane().add(buttonPanel, gridBagConstraints);

        pack();
    }//GEN-END:initComponents

    private void weeksButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_weeksButtonActionPerformed
        // Add your handling code here:
        Calendar cal = myCalendar.getCalendar();

        String s=null;
        do {
            if (GeneralProgram.isSupportFor("1.4"))
            s = JOptionPane.showInputDialog(this,rb.getString("Calendar.plusMinusWeeks"),String.valueOf("+1"));
            else
            s = JOptionPane.showInputDialog(this,rb.getString("Calendar.plusMinusWeeks"));
            if (s==null) break;
            try {                
                if (s.startsWith("+")) s=s.substring(1,s.length());
                int val = Integer.parseInt(s.trim());
                add(val*7);
            } catch (Exception e) {
                s=null;
            }
        } while (s==null);        
        
    }//GEN-LAST:event_weeksButtonActionPerformed

    private void daysButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_daysButtonActionPerformed
        // Add your handling code here:
        
        String s=null;
        do {
            if (GeneralProgram.isSupportFor("1.4"))
            s = JOptionPane.showInputDialog(this,rb.getString("Calendar.plusMinusDays"),String.valueOf("+1"));
            else
            s = JOptionPane.showInputDialog(this,rb.getString("Calendar.plusMinusDays"));
            if (s==null) break;
            try {                
                if (s.startsWith("+")) s=s.substring(1,s.length());
                int val = Integer.parseInt(s.trim());
                add(val);
            } catch (Exception e) {
                s=null;
            }
        } while (s==null);        
    }//GEN-LAST:event_daysButtonActionPerformed

    // add val days to the calendar
    private void add(int val) {
       Calendar cal = myCalendar.getCalendar();        
       cal.add(Calendar.DATE,val);
       myCalendar.setCalendar(cal);
       updateLabel(cal);
    }
    
    private void weekOfYearButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_weekOfYearButtonActionPerformed
        // Add your handling code here:
        Calendar cal = myCalendar.getCalendar();

        String s=null;
        do {
            if (GeneralProgram.isSupportFor("1.4")) 
            s = JOptionPane.showInputDialog(this,rb.getString("Calendar.weekOfYear"),String.valueOf(cal.get(Calendar.WEEK_OF_YEAR)));
             else
            s = JOptionPane.showInputDialog(this,rb.getString("Calendar.weekOfYear"));
            if (s==null) break;
            try {
                int val = Integer.parseInt(s.trim());
                cal.set(Calendar.WEEK_OF_YEAR,val);
                myCalendar.setCalendar(cal);
                updateLabel(cal);
            } catch (Exception e) {
                s=null;
            }
        } while (s==null);

    }//GEN-LAST:event_weekOfYearButtonActionPerformed

    private void myCalendarPropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_myCalendarPropertyChange
        // Add your handling code here:
        if (evt.getPropertyName().equals("calendar")) {
          Calendar calendar = (Calendar) evt.getNewValue();
          updateLabel(calendar);
          myCalendar.setCalendar(calendar);
        }

    }//GEN-LAST:event_myCalendarPropertyChange

    private void updateLabel(Calendar calendar) {
        DateFormat df = DateFormat.getDateInstance(DateFormat.LONG,myCalendar.getLocale());
        dateLabel.setText(df.format(calendar.getTime())+" ("+calendar.get(Calendar.WEEK_OF_YEAR)+")");
    }

    private void todayButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_todayButtonActionPerformed
        // Add your handling code here:
        myCalendar.setCalendar(new GregorianCalendar());
    }//GEN-LAST:event_todayButtonActionPerformed

    private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelButtonActionPerformed
        // Add your handling code here:
        status[0]=false;
        closeDialog(null);
    }//GEN-LAST:event_cancelButtonActionPerformed

    private void okButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_okButtonActionPerformed
        // Add your handling code here:
        Calendar cal = myCalendar.getCalendar();
        calendar.set(cal.get(Calendar.YEAR),cal.get(Calendar.MONTH),cal.get(Calendar.DATE));
        status[0]=true;
        closeDialog(null);
    }//GEN-LAST:event_okButtonActionPerformed

    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        setVisible(false);
        dispose();
    }//GEN-LAST:event_closeDialog

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
       // new CalendarChooserDialog(new javax.swing.JFrame(), true).show();
    }


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel buttonPanel;
    private javax.swing.JPanel calendarPanel;
    private javax.swing.JButton cancelButton;
    private javax.swing.JLabel dateLabel;
    private javax.swing.JButton daysButton;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel labelPanel;
    private com.toedter.calendar.JCalendar myCalendar;
    private javax.swing.JButton okButton;
    private javax.swing.JButton todayButton;
    private javax.swing.JButton weekOfYearButton;
    private javax.swing.JButton weeksButton;
    // End of variables declaration//GEN-END:variables

}
