/******************************************************************************
 *
 * Numerical Chameleon version 1.6.0 - conversion tool
 * Copyright (C) 2001-2004  Dipl.-Inf. (FH) Johann Nepomuk Loefflmann,
 * All Rights Reserved, http://www.jonelo.de
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * e-Mail: jonelo@jonelo.de
 *
 *****************************************************************************/
package jonelo.NumericalChameleon.Clusters;

import jonelo.NumericalChameleon.*;
import java.math.*;
import java.util.*;



public class ClusterAlphaPhone extends ClusterObject {

    public static final int INTERNAL=1;
    public final static String CODE="ALPHAPHONE";

    private Vector vs, vt;

    public static String
      ALPHA="Phone# (alphanumerical)",
      NUM="Phone# (numerical)";

    /** Creates new ClusterBase35 */
    public ClusterAlphaPhone() {
        vs = new Vector();
        vs.add(new NcRecord(ALPHA,"int"));

        vt = new Vector();
        vt.add(new NcRecord(NUM,"int"));
    }

    public Vector getSourceEntries() {
        return vs;
    }

    public Vector getTargetEntries() {
        return vt;
    }

    public int getSourceDefault() {
        return 0;
    }

    public int getTargetDefault() {
        return 0;
    }

    public int getPreferredPrecision()  {
        return -1;
    }

    public boolean isOneway() {
      return true;
    }

    public String getOutput(int s, int t) throws Exception
    {
        StringBuffer sb = new StringBuffer();
        StringBuffer inputsb = new StringBuffer(input.toLowerCase());
        for (int i=0; i < inputsb.length(); i++)
        {
           switch (inputsb.charAt(i))
           {
              case 'a':
              case 'b':
              case 'c': sb.append('2'); break;
              case 'd':
              case 'e':
              case 'f': sb.append('3'); break;
              case 'g':
              case 'h':
              case 'i': sb.append('4'); break;
              case 'j':
              case 'k':
              case 'l': sb.append('5'); break;
              case 'm':
              case 'n':
              case 'o': sb.append('6'); break;
              case 'p':
              case 'q':
              case 'r':
              case 's': sb.append('7'); break;
              case 't':
              case 'u':
              case 'v': sb.append('8'); break;
              case 'w':
              case 'x':
              case 'y':
              case 'z': sb.append('9'); break;
              default: sb.append(input.charAt(i));
           }

        }
        return sb.toString();
    }


    public String addValue(BigDecimal plus, int sourceindex) throws Exception {
        return input;
    }

    public String getTransferValue(int s) throws Exception {
        return null;
    }
    
    public String getInitialValue() {
        return "555-HELP";
    }

    public String setValue(BigDecimal big, int sourceindex) throws Exception {
        return null;
    }

}
