/******************************************************************************
 *
 * Numerical Chameleon version 1.6.0 - conversion tool
 * Copyright (C) 2001-2004  Dipl.-Inf. (FH) Johann Nepomuk Loefflmann,
 * All Rights Reserved, http://www.jonelo.de
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * e-Mail: jonelo@jonelo.de
 *
 *****************************************************************************/
package jonelo.NumericalChameleon.Clusters;
import jonelo.NumericalChameleon.Main;
import jonelo.NumericalChameleon.*;
import java.math.*;
import java.util.*;
import java.io.*;



public class ClusterDialCode extends ClusterObject {

    public static final int INTERNAL=230;
    public final static String CODE="DIALCODE";

    private Vector v;
    private Hashtable hashtableFrom;
    private Hashtable hashtableTo;
    int sourceDefault=0;
    int targetDefault=0;

    public ClusterDialCode() {
        v = new Vector();
        hashtableFrom = new Hashtable();
        hashtableTo = new Hashtable();
        try {
        // read file
        InputStream is = getClass().getResourceAsStream("/data/lists/intphone.list");
        BufferedReader br = new BufferedReader (new InputStreamReader(is,"ISO-8859-1"));
        String thisLine;
        StringBuffer sb = new StringBuffer();
        StringTokenizer st = null;
              String to = null;
              String from = null;
        int index=0;
        while ((thisLine = br.readLine()) != null)
        {
           if (!thisLine.startsWith("#") && !thisLine.equals(""))
           {

              // build hashtable and vector
              st = new StringTokenizer(thisLine,":");
              String countrycode = st.nextToken().toLowerCase();
              index++;
              v.add(new NcRecord((String)Main.iso3166.getString(countrycode.toLowerCase()),countrycode.toLowerCase()));
              if (st.hasMoreTokens())
              {
                to = st.nextToken();
              } else to="";
              if (st.hasMoreTokens())
              {
                 from = st.nextToken();
              } else from="";

              //hashtable.put(countrycode,new DialCode(from,to));
              hashtableFrom.put(countrycode,from);
              hashtableTo.put(countrycode,to);
           }
        }
        br.close();

        // sortieren
        Object[] ncarr = v.toArray();
        Arrays.sort(ncarr);

        v.clear();
        for (int i=0; i < ncarr.length; i++)
        {
            v.add(ncarr[i]);
            if (((NcRecord)ncarr[i]).getIcon().equals("de")) sourceDefault=i;
            if (((NcRecord)ncarr[i]).getIcon().equals("us")) targetDefault=i;
        }

        } catch (Exception e) { System.err.println(e);}
    }

    public Vector getSourceEntries() {
        return v;
    }

    public Vector getTargetEntries() {
        return v;
    }

    public int getSourceDefault() {
        return sourceDefault;
    }

    public int getTargetDefault() {
        return targetDefault;
    }

    public int getPreferredPrecision()  {
        return -1;
    }

    public boolean acceptEmptyStrings() {
        return true;
    }

    public String getOutput(int s, int t) throws Exception {
        String codeSource = ((NcRecord)v.elementAt(s)).getIcon();
        String codeTarget = ((NcRecord)v.elementAt(t)).getIcon();

        // "Keine Verbindung unter dieser Vorwahl"
        if (codeSource.equals(codeTarget)) return "";

        return hashtableFrom.get(codeSource)+" "+hashtableTo.get(codeTarget);
    }

    public String getInitialValue() {
       return "";
    }

    public String addValue(BigDecimal plus, int sourceindex) throws Exception {
        return input;
        /*BigDecimal big = new BigDecimal(getInput());
        big=big.add(plus);
        return big.toString(); */
    }

    public String getTransferValue(int s) throws Exception {
        return null;
    }

    public String setValue(BigDecimal big, int sourceindex) throws Exception {
        return null;
    }

}
