/******************************************************************************
 *
 * Numerical Chameleon version 1.6.0 - conversion tool
 * Copyright (C) 2001-2004  Dipl.-Inf. (FH) Johann Nepomuk Loefflmann,
 * All Rights Reserved, http://www.jonelo.de
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * e-Mail: jonelo@jonelo.de
 *
 *****************************************************************************/
package jonelo.NumericalChameleon.ExchangeRates;
import java.util.Vector;
import java.io.*;

public class ExchangeRates {
    private Vector vector;
    private String date;
    private boolean logic;
    private String preferredFilter;
    private String preferredDir;    

    /** Creates new ExchangeRates */
    public ExchangeRates() {
        vector = new Vector();
    }

    public void clear() {
        vector.clear();
    }

    public void add(String string) {
        vector.add(string);
    }

    public int count() {
        return (vector.size());
    }

    public boolean success() {
        return (vector.size() > 0);
    }

    public void setDate(String date) {
        this.date=date;
    }

    public String getDate() {
        return date;
    }

    public void setLogic(boolean logic) {
        this.logic=logic;
    }

    public boolean getLogic() {
        return logic;
    }

    public void setPreferredFilter(String filter) {
        this.preferredFilter=filter;
    }

    public String getPreferredFilter() {
        return preferredFilter;
    }

    public void setPreferredDirectory(String dir) {
        this.preferredDir=dir;
    }

    public String getPreferredDirectory() {
        return preferredDir;
    }    

    public void writeToDisk() throws Exception
    {
       FileOutputStream fos = null;
       try {
         fos = new FileOutputStream ("../data/units/exchange_rates.list");
       } catch (Exception e) {
         fos = new FileOutputStream ("../../data/units/exchange_rates.list");
       }
       BufferedWriter myOutput = new BufferedWriter (new OutputStreamWriter(fos));

        // sort
       for (int i=0; i < vector.size(); i++) {
          myOutput.write(vector.elementAt(i)+"\n");
       }
       myOutput.close();
       fos.close();
    }
}




