/******************************************************************************
 *
 * Numerical Chameleon version 1.6.0 - conversion tool
 * Copyright (C) 2001-2004  Dipl.-Inf. (FH) Johann Nepomuk Loefflmann,
 * All Rights Reserved, http://www.jonelo.de
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * e-Mail: jonelo@jonelo.de
 *
 *****************************************************************************/

package jonelo.NumericalChameleon.ExchangeRates;
import jonelo.sugar.io.GeneralIO;
import jonelo.sugar.gui.GeneralGUI;
import jonelo.sugar.util.GeneralString;
import jonelo.sugar.util.GeneralProgram;
import java.util.*;
import javax.swing.*;
import jonelo.sugar.io.ExampleFileFilter;
import com.Ostermiller.util.Browser;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.Toolkit;
import java.io.*;
import java.awt.*;

public class ExchangeRatesUpdateDialog extends javax.swing.JDialog {

    private Vector exchangeRatesUpdateVector = null;
    private String filenameDefinition;
    private javax.swing.Timer timer;
    private LongTask task;
    private static boolean debug=false;
    private ResourceBundle rb;
    private JFileChooser openChooser;
    private ExchangeRates exchangeRates;


    /** Creates new form ExchangeRatesUpdateDialog */
    public ExchangeRatesUpdateDialog (java.awt.Frame parent, ResourceBundle rb, ExchangeRates exchangeRates) {
        super(parent, true);


        this.exchangeRates=exchangeRates;
        this.rb=rb;

        if (GeneralProgram.isSupportFor("1.4") && parent.isUndecorated()) {
            setUndecorated(true);
            getRootPane().setWindowDecorationStyle(JRootPane.FRAME);
        }

        setVisible(false);
        openChooser= new JFileChooser();
        task = new LongTask(exchangeRates);
        initComponents();

        progressBar.setValue(0);
        progressBar.setMinimum(0);
        progressBar.setMaximum(task.getLengthOfTask());
        progressBar.setStringPainted(true);

        timer = new javax.swing.Timer(500, new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                int here = task.getCurrent();
                progressBar.setValue(here);
                progressBar.setString((here*100/task.getLengthOfTask())+" %");

                if (task.done()) {
                    //Toolkit.getDefaultToolkit().beep();
                    timer.stop();
                    startButton.setEnabled(true);
                    logLabel.setIcon(null);
                    progressBar.setValue(progressBar.getMinimum());
                    progressBar.setString("0 %");
                    Toolkit.getDefaultToolkit().beep();
                }
            }
        });

        prepareExchangeRateUpdateList();
//        rateServiceComboBoxItemStateChanged();
        GeneralGUI.setLocationRelativeTo(this,parent);
        ComponentOrientation ce = ComponentOrientation.getOrientation(Locale.getDefault()); 
        if (!ce.isLeftToRight()) GeneralGUI.applyOrientation(dialogPanel, ce);
        show();
    }

    public static void setDebug(boolean flag) {
        debug=flag;
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        java.awt.GridBagConstraints gridBagConstraints;

        dialogPanel = new javax.swing.JPanel();
        jPanel5 = new javax.swing.JPanel();
        okButton = new javax.swing.JButton();
        cancelButton = new javax.swing.JButton();
        stepsTabbedPane = new javax.swing.JTabbedPane();
        jPanel2 = new javax.swing.JPanel();
        jLabel4 = new javax.swing.JLabel();
        jPanel7 = new javax.swing.JPanel();
        rateServiceComboBox = new javax.swing.JComboBox();
        jPanel6 = new javax.swing.JPanel();
        leftButton = new javax.swing.JButton();
        rightButton = new javax.swing.JButton();
        jLabel9 = new javax.swing.JLabel();
        jScrollPane3 = new javax.swing.JScrollPane();
        descriptionTextArea = new javax.swing.JTextArea();
        toStep2Button = new javax.swing.JButton();
        jPanel3 = new javax.swing.JPanel();
        jLabel5 = new javax.swing.JLabel();
        visitTextField = new javax.swing.JTextField();
        copyButton = new javax.swing.JButton();
        jLabel7 = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        instructionTextArea = new javax.swing.JTextArea();
        toStep1Button = new javax.swing.JButton();
        toStep3Button = new javax.swing.JButton();
        jPanel4 = new javax.swing.JPanel();
        jLabel6 = new javax.swing.JLabel();
        filenameTextField = new javax.swing.JTextField();
        filechooseButton = new javax.swing.JButton();
        startButton = new javax.swing.JButton();
        progressBar = new javax.swing.JProgressBar();
        jScrollPane2 = new javax.swing.JScrollPane();
        logTextArea = new javax.swing.JTextArea();
        logLabel = new javax.swing.JLabel();

        setTitle(rb.getString("GUI.Rates.title"));
        setModal(true);
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });

        dialogPanel.setLayout(new java.awt.GridBagLayout());

        dialogPanel.setBorder(new javax.swing.border.EtchedBorder());
        jPanel5.setLayout(new java.awt.GridBagLayout());

        okButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/core/images/main/Import16.gif")));
        okButton.setText(rb.getString("GUI.General.Update"));
        okButton.setEnabled(false);
        okButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                okButtonActionPerformed(evt);
            }
        });

        jPanel5.add(okButton, new java.awt.GridBagConstraints());

        cancelButton.setText(rb.getString("GUI.General.Cancel"));
        cancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelButtonActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        jPanel5.add(cancelButton, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 15, 15);
        dialogPanel.add(jPanel5, gridBagConstraints);

        stepsTabbedPane.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                stepsTabbedPaneStateChanged(evt);
            }
        });

        jPanel2.setLayout(new java.awt.GridBagLayout());

        jPanel2.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(10, 10, 10, 10)));
        jLabel4.setText(rb.getString("GUI.Rates.Service.Label"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel2.add(jLabel4, gridBagConstraints);

        jPanel7.setLayout(new java.awt.GridBagLayout());

        rateServiceComboBox.setMinimumSize(new java.awt.Dimension(320, 26));
        rateServiceComboBox.setPreferredSize(new java.awt.Dimension(320, 26));
        rateServiceComboBox.setOpaque(false);
        rateServiceComboBox.setRenderer(new com.incors.plaf.kunststoff.ModifiedDefaultListCellRenderer());
        rateServiceComboBox.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                rateServiceComboBoxItemStateChanged(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.weightx = 1.0;
        jPanel7.add(rateServiceComboBox, gridBagConstraints);

        jPanel6.setLayout(new java.awt.GridLayout(2, 0));

        leftButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/core/images/main/up3.gif")));
        leftButton.setMargin(new java.awt.Insets(1, 1, 1, 1));
        leftButton.setMaximumSize(new java.awt.Dimension(21, 21));
        leftButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                leftButtonActionPerformed(evt);
            }
        });

        jPanel6.add(leftButton);

        rightButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/core/images/main/down3.gif")));
        rightButton.setMargin(new java.awt.Insets(1, 1, 1, 1));
        rightButton.setMaximumSize(new java.awt.Dimension(21, 21));
        rightButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                rightButtonActionPerformed(evt);
            }
        });

        jPanel6.add(rightButton);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        jPanel7.add(jPanel6, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanel2.add(jPanel7, gridBagConstraints);

        jLabel9.setText(rb.getString("GUI.Rates.Service.Description"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 0, 0);
        jPanel2.add(jLabel9, gridBagConstraints);

        jScrollPane3.setMinimumSize(new java.awt.Dimension(320, 120));
        jScrollPane3.setPreferredSize(new java.awt.Dimension(320, 120));
        descriptionTextArea.setBackground(java.awt.Color.black);
        descriptionTextArea.setEditable(false);
        descriptionTextArea.setEnabled(false);
        jScrollPane3.setViewportView(descriptionTextArea);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        jPanel2.add(jScrollPane3, gridBagConstraints);

        toStep2Button.setIcon(new javax.swing.ImageIcon(getClass().getResource("/core/images/main/Forward16.gif")));
        toStep2Button.setText(rb.getString("GUI.Rates.Continue.Button"));
        toStep2Button.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
        toStep2Button.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                toStep2ButtonActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(3, 0, 0, 0);
        jPanel2.add(toStep2Button, gridBagConstraints);

        stepsTabbedPane.addTab("1.", new javax.swing.ImageIcon(getClass().getResource("/core/images/main/currency.png")), jPanel2, "");

        jPanel3.setLayout(new java.awt.GridBagLayout());

        jPanel3.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(10, 10, 10, 10)));
        jLabel5.setText(rb.getString("GUI.Rates.Visit.Label"));
        jLabel5.setPreferredSize(new java.awt.Dimension(320, 17));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel3.add(jLabel5, gridBagConstraints);

        visitTextField.setEditable(false);
        visitTextField.setMinimumSize(new java.awt.Dimension(290, 21));
        visitTextField.setPreferredSize(new java.awt.Dimension(290, 21));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        jPanel3.add(visitTextField, gridBagConstraints);

        copyButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/core/images/main/earth16.png")));
        copyButton.setText(rb.getString("GUI.General.Go"));
        copyButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                copyButtonActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanel3.add(copyButton, gridBagConstraints);

        jLabel7.setText(rb.getString("GUI.Rates.Visit.Instructions.Label"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(3, 0, 0, 0);
        jPanel3.add(jLabel7, gridBagConstraints);

        jScrollPane1.setPreferredSize(new java.awt.Dimension(320, 120));
        jScrollPane1.setMinimumSize(new java.awt.Dimension(320, 120));
        instructionTextArea.setEditable(false);
        instructionTextArea.setBackground(java.awt.Color.black);
        instructionTextArea.setEnabled(false);
        jScrollPane1.setViewportView(instructionTextArea);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        jPanel3.add(jScrollPane1, gridBagConstraints);

        toStep1Button.setIcon(new javax.swing.ImageIcon(getClass().getResource("/core/images/main/Back16.gif")));
        toStep1Button.setText(rb.getString("GUI.Rates.Back.Button"));
        toStep1Button.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                toStep1ButtonActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(3, 0, 0, 0);
        jPanel3.add(toStep1Button, gridBagConstraints);

        toStep3Button.setIcon(new javax.swing.ImageIcon(getClass().getResource("/core/images/main/Forward16.gif")));
        toStep3Button.setText(rb.getString("GUI.Rates.Continue.Button"));
        toStep3Button.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
        toStep3Button.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                toStep3ButtonActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(3, 0, 0, 0);
        jPanel3.add(toStep3Button, gridBagConstraints);

        stepsTabbedPane.addTab("2.", new javax.swing.ImageIcon(getClass().getResource("/core/images/main/earth24.png")), jPanel3, "");

        jPanel4.setLayout(new java.awt.GridBagLayout());

        jPanel4.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(10, 10, 10, 10)));
        jLabel6.setText(rb.getString("GUI.Rates.Include.Label"));
        jLabel6.setPreferredSize(new java.awt.Dimension(320, 17));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel4.add(jLabel6, gridBagConstraints);

        filenameTextField.setPreferredSize(new java.awt.Dimension(250, 21));
        filenameTextField.setMinimumSize(new java.awt.Dimension(250, 21));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        jPanel4.add(filenameTextField, gridBagConstraints);

        filechooseButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/core/images/main/Open16.gif")));
        filechooseButton.setText(rb.getString("GUI.General.SelectFile"));
        filechooseButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                filechooseButtonActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanel4.add(filechooseButton, gridBagConstraints);

        startButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/core/images/main/Zoom16.gif")));
        startButton.setText(rb.getString("GUI.Rates.Include.Start"));
        startButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                startButtonActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanel4.add(startButton, gridBagConstraints);

        progressBar.setPreferredSize(new java.awt.Dimension(250, 14));
        progressBar.setString("0 %");
        progressBar.setName("progressBar");
        progressBar.setMinimumSize(new java.awt.Dimension(250, 14));
        progressBar.setStringPainted(true);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        jPanel4.add(progressBar, gridBagConstraints);

        jScrollPane2.setVerticalScrollBarPolicy(javax.swing.JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
        jScrollPane2.setPreferredSize(new java.awt.Dimension(320, 120));
        jScrollPane2.setMinimumSize(new java.awt.Dimension(320, 120));
        logTextArea.setBackground(java.awt.Color.black);
        logTextArea.setEditable(false);
        logTextArea.setEnabled(false);
        jScrollPane2.setViewportView(logTextArea);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        jPanel4.add(jScrollPane2, gridBagConstraints);

        logLabel.setText(rb.getString("GUI.Rates.Include.Log"));
        logLabel.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel4.add(logLabel, gridBagConstraints);

        stepsTabbedPane.addTab("3.", new javax.swing.ImageIcon(getClass().getResource("/core/images/main/Import24.gif")), jPanel4, "");

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.ipadx = 10;
        gridBagConstraints.ipady = 10;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(15, 15, 5, 15);
        dialogPanel.add(stepsTabbedPane, gridBagConstraints);

        getContentPane().add(dialogPanel, java.awt.BorderLayout.CENTER);

        pack();
    }//GEN-END:initComponents

    private void toStep1ButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_toStep1ButtonActionPerformed
        // Add your handling code here:
        stepsTabbedPane.setSelectedIndex(0);
    }//GEN-LAST:event_toStep1ButtonActionPerformed

    private void okButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_okButtonActionPerformed
        // Add your handling code here:
        closeWindow();
    }//GEN-LAST:event_okButtonActionPerformed

    private void rightButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_rightButtonActionPerformed
        // Add your handling code here:
      int now = rateServiceComboBox.getSelectedIndex();
      int all = rateServiceComboBox.getItemCount();
      if (now+1 < all) rateServiceComboBox.setSelectedIndex(now+1); else rateServiceComboBox.setSelectedIndex(0);

    }//GEN-LAST:event_rightButtonActionPerformed

    private void leftButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_leftButtonActionPerformed
        // Add your handling code here:
      int now = rateServiceComboBox.getSelectedIndex();
      int all = rateServiceComboBox.getItemCount();
      if (now > 0) rateServiceComboBox.setSelectedIndex(now-1); else rateServiceComboBox.setSelectedIndex(all-1);
    }//GEN-LAST:event_leftButtonActionPerformed

    private void stepsTabbedPaneStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_stepsTabbedPaneStateChanged
        // Add your handling code here:
        visitTextField.setCaretPosition(0);
    }//GEN-LAST:event_stepsTabbedPaneStateChanged

    private void toStep2ButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_toStep2ButtonActionPerformed
        // Add your handling code here:
        stepsTabbedPane.setSelectedIndex(1);
    }//GEN-LAST:event_toStep2ButtonActionPerformed

    private void toStep3ButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_toStep3ButtonActionPerformed
        // Add your handling code here:
        stepsTabbedPane.setSelectedIndex(2);
    }//GEN-LAST:event_toStep3ButtonActionPerformed

    private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelButtonActionPerformed
        // Add your handling code here:
        cancel();
        closeWindow();
    }//GEN-LAST:event_cancelButtonActionPerformed

    private void filechooseButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_filechooseButtonActionPerformed
        // Add your handling code here:
        pressOpen();
    }//GEN-LAST:event_filechooseButtonActionPerformed

    private void copyButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_copyButtonActionPerformed
        // Add your handling code here:
        GeneralIO.setClipboard(visitTextField.getText());
        // visit the website
        try {
          Browser.displayURL(visitTextField.getText());
        } catch (Exception e) {          
          System.out.println(e);
        }        
//        NewBrowserLauncher newBrowserLauncher = new NewBrowserLauncher();
//        newBrowserLauncher.openURL();
    }//GEN-LAST:event_copyButtonActionPerformed

    public void checkFileForInput(String filename) throws Exception
    {
        if (filename==null)
            throw new Exception(rb.getString("Error.FileNotSpecified"));
        if (filename.equals(""))
            throw new Exception(rb.getString("Error.FileNotSpecified"));

       File file = new File(filenameTextField.getText());
       if (!file.exists())
           throw new Exception(GeneralString.message(rb.getString("Error.FileDoesNotExist"),filename));
       if (!file.isFile())
           throw new Exception(GeneralString.message(rb.getString("Error.NotAFile"),filename));
       if (!file.canRead())
           throw new Exception(GeneralString.message(rb.getString("Error.ReadProblem"),filename));
    }

    private void startButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_startButtonActionPerformed
        // Add your handling code here:
        // check input
       try {
           logLabel.setIcon(new javax.swing.ImageIcon(getClass().getResource("/core/images/main/loading.gif")));
           startButton.setEnabled(false);
           okButton.setEnabled(false);
           checkFileForInput(filenameTextField.getText());
           exchangeRates.clear();
           task.setRatesFilename("/data/rates/"+filenameDefinition);
           task.setIncludeFilename(filenameTextField.getText()); // "../data/rates/rates.html"
           task.setTextArea(logTextArea);
           task.setButton(okButton);
           logTextArea.append("");
           task.go();
           timer.start();
       } catch (Exception e)
       {
           logLabel.setIcon(null);
           JOptionPane.showMessageDialog(this,e.getMessage(),rb.getString("Error.errorname"),JOptionPane.ERROR_MESSAGE);
           logLabel.setIcon(null);
           startButton.setEnabled(true);
       }
    }//GEN-LAST:event_startButtonActionPerformed

    private void rateServiceComboBoxItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_rateServiceComboBoxItemStateChanged
        // Add your handling code here:
        rateServiceComboBoxItemStateChanged();
    }//GEN-LAST:event_rateServiceComboBoxItemStateChanged

    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        cancel();
        closeWindow();
    }//GEN-LAST:event_closeDialog

    private void cancel() {
        task.stop();
        exchangeRates.clear();
    }

    private void closeWindow() {
       setVisible(false);
       dispose();
    }

    private void rateServiceComboBoxItemStateChanged() {
        logTextArea.setText("");
        try{
           Properties props = new Properties();

           openChooser.resetChoosableFileFilters();
           filenameDefinition = (String)exchangeRatesUpdateVector.get(rateServiceComboBox.getSelectedIndex());
           exchangeRates.setPreferredFilter((String)rateServiceComboBox.getSelectedItem());
           props.load(getClass().getResourceAsStream("/data/rates/"+filenameDefinition));

           String filetype=props.getProperty("filechooser","");
           if (!filetype.equals("")) {
             Vector v = new Vector();
             StringTokenizer st = new StringTokenizer(filetype,",");
             while (st.hasMoreTokens()) {
                 String tok = st.nextToken();
                 v.add(tok);
             }

             String[] types = new String[v.size()];
             for (int i=0; i < types.length; i++) {
                 types[i]=(String)v.elementAt(i);
             }
             ExampleFileFilter filter = new ExampleFileFilter(types);
             openChooser.addChoosableFileFilter(filter);
             openChooser.setFileFilter(filter);
           }

           descriptionTextArea.setText(props.getProperty("description",""));
           visitTextField.setText(props.getProperty("visit",""));
           instructionTextArea.setText(props.getProperty("instruction",""));
           instructionTextArea.setCaretPosition(0);
         }  catch (Exception e) {
           System.err.println(e.toString());
         }
    }


    private void prepareExchangeRateUpdateList() {
       if (debug) System.out.print ("Loading exchange rates update filter ... ");
        try {
           String myHome = "../data/rates/";

           exchangeRatesUpdateVector = GeneralIO.ls (myHome,".filter");
           if (exchangeRatesUpdateVector==null) throw new Exception (rb.getString("GUI.Rates.NoFilter"));
           rateServiceComboBox.setModel(getComboBoxModel(exchangeRatesUpdateVector));

           if (!exchangeRates.getPreferredFilter().equals(""))
                rateServiceComboBox.setSelectedItem(exchangeRates.getPreferredFilter());
           rateServiceComboBoxItemStateChanged();

          if (debug) System.out.println("OK.");
        }  catch (Exception e) {
            System.err.println("ERROR: "+e.getMessage());
        }
    }

    private javax.swing.ComboBoxModel getComboBoxModel(Vector data) {
      javax.swing.JComboBox cb = new javax.swing.JComboBox(data);
      return cb.getModel();
    }


  private void pressOpen() {
    String temp = exchangeRates.getPreferredDirectory();
    if (temp != null) openChooser.setCurrentDirectory(new File(temp));
    int state=openChooser.showOpenDialog(this);
    File sourceFile = openChooser.getSelectedFile();
    if ((sourceFile != null) && (state == JFileChooser.APPROVE_OPTION)) {
       filenameTextField.setText(sourceFile.getPath());
       exchangeRates.setPreferredDirectory(sourceFile.getAbsolutePath());
    }
    /*
    else // Cancel is pressed
    if(state == JFileChooser.CANCEL_OPTION)
    {
    } else // FrameCooser is closed
    if(state == JFileChooser.ERROR_OPTION)
    {
    }
     */
  }


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton cancelButton;
    private javax.swing.JButton copyButton;
    private javax.swing.JTextArea descriptionTextArea;
    private javax.swing.JPanel dialogPanel;
    private javax.swing.JButton filechooseButton;
    private javax.swing.JTextField filenameTextField;
    private javax.swing.JTextArea instructionTextArea;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JPanel jPanel6;
    private javax.swing.JPanel jPanel7;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JButton leftButton;
    private javax.swing.JLabel logLabel;
    private javax.swing.JTextArea logTextArea;
    private javax.swing.JButton okButton;
    private javax.swing.JProgressBar progressBar;
    private javax.swing.JComboBox rateServiceComboBox;
    private javax.swing.JButton rightButton;
    private javax.swing.JButton startButton;
    private javax.swing.JTabbedPane stepsTabbedPane;
    private javax.swing.JButton toStep1Button;
    private javax.swing.JButton toStep2Button;
    private javax.swing.JButton toStep3Button;
    private javax.swing.JTextField visitTextField;
    // End of variables declaration//GEN-END:variables

}
