/******************************************************************************
 *
 * Numerical Chameleon version 1.6.0 - conversion tool
 * Copyright (C) 2001-2004  Dipl.-Inf. (FH) Johann Nepomuk Loefflmann,
 * All Rights Reserved, http://www.jonelo.de
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * e-Mail: jonelo@jonelo.de
 *
 *****************************************************************************/

package jonelo.NumericalChameleon.Find;
import jonelo.NumericalChameleon.Main;
import jonelo.sugar.gui.*;
import jonelo.sugar.util.GeneralProgram;
import javax.swing.*;
import java.awt.event.*;
import java.util.*;
import java.awt.*;

public class FindDialog extends javax.swing.JDialog {
   private int next=0;
    private Main main;
    int progressMax=0;
    JComboBox box;
    int targetProgressBarValue =0;
    int sourceProgressBarValue=0;
    String sourceText="", targetText="";
    ResourceBundle rb;

    /** Creates new form FindDialog */
    public FindDialog(java.awt.Frame parent, boolean modal, Main main, boolean srcIndicator) {
        super(parent, modal);
        if (GeneralProgram.isSupportFor("1.4") && parent.isUndecorated()) {
            setUndecorated(true);
            getRootPane().setWindowDecorationStyle(JRootPane.FRAME);
        }        
        this.main = main;
        this.rb = main.getResourceBundle();
        setTitle(rb.getString("GUI.Menu.Find"));
        initComponents();

        buttonGroup.add(sourceRadioButton);
        buttonGroup.add(targetRadioButton);
        sourceRadioButton.setSelected(srcIndicator);
        targetRadioButton.setSelected(!srcIndicator);
        findProgressBar.setMinimum(0);
        switchit();
        GeneralGUI.setLocationRelativeTo(this,parent);
        ComponentOrientation ce = ComponentOrientation.getOrientation(Locale.getDefault()); 
        if (!ce.isLeftToRight()) GeneralGUI.applyOrientation(findPanel, ce);
          
        findTextField.requestFocus();
        show();
    }

    private void switchit() {
        // source
        if (sourceRadioButton.isSelected()) {
          targetProgressBarValue = findProgressBar.getValue();
          targetText = findTextField.getText();
          box=main.getSourceBox();
          findProgressBar.setMaximum(box.getItemCount());
          findProgressBar.setValue(sourceProgressBarValue);
          next=sourceProgressBarValue;
          if (sourceText.equals(""))
            findTextField.setText(targetText); else
            findTextField.setText(sourceText);

        }
        // target
        else {
          sourceProgressBarValue = findProgressBar.getValue();
          sourceText = findTextField.getText();
          box=main.getTargetBox();
          findProgressBar.setMaximum(box.getItemCount());
          findProgressBar.setValue(targetProgressBarValue);
          next=targetProgressBarValue;
          if (targetText.equals(""))
            findTextField.setText(sourceText); else
            findTextField.setText(targetText);
        }
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        java.awt.GridBagConstraints gridBagConstraints;

        buttonGroup = new javax.swing.ButtonGroup();
        findPanel = new javax.swing.JPanel();
        findLabel = new javax.swing.JLabel();
        findTextField = new javax.swing.JTextField();
        findProgressBar = new javax.swing.JProgressBar();
        jPanel3 = new javax.swing.JPanel();
        matchUpperLowerCaseCheckBox = new javax.swing.JCheckBox();
        jSeparator1 = new javax.swing.JSeparator();
        jPanel4 = new javax.swing.JPanel();
        sourceRadioButton = new javax.swing.JRadioButton();
        targetRadioButton = new javax.swing.JRadioButton();
        buttonPanel = new javax.swing.JPanel();
        resetButton = new javax.swing.JButton();
        findButton = new javax.swing.JButton();
        cancelButton = new javax.swing.JButton();

        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });

        findPanel.setLayout(new java.awt.GridBagLayout());

        findPanel.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(15, 15, 10, 15)));
        findLabel.setText(rb.getString("GUI.Menu.Find"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 0, 5);
        findPanel.add(findLabel, gridBagConstraints);

        findTextField.setPreferredSize(new java.awt.Dimension(250, 20));
        findTextField.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyReleased(java.awt.event.KeyEvent evt) {
                findTextFieldKeyReleased(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        findPanel.add(findTextField, gridBagConstraints);

        findProgressBar.setStringPainted(true);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        findPanel.add(findProgressBar, gridBagConstraints);

        jPanel3.setLayout(new java.awt.GridBagLayout());

        matchUpperLowerCaseCheckBox.setText(rb.getString("GUI.Find.Match"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanel3.add(matchUpperLowerCaseCheckBox, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanel3.add(jSeparator1, gridBagConstraints);

        jPanel4.setLayout(new java.awt.GridBagLayout());

        sourceRadioButton.setSelected(true);
        sourceRadioButton.setText(rb.getString("GUI.Menu.Source"));
        sourceRadioButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                sourceRadioButtonActionPerformed(evt);
            }
        });
        sourceRadioButton.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                sourceRadioButtonItemStateChanged(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel4.add(sourceRadioButton, gridBagConstraints);

        targetRadioButton.setText(rb.getString("GUI.Menu.Target"));
        targetRadioButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                targetRadioButtonActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        jPanel4.add(targetRadioButton, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanel3.add(jPanel4, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(10, 0, 0, 0);
        findPanel.add(jPanel3, gridBagConstraints);

        getContentPane().add(findPanel, java.awt.BorderLayout.CENTER);

        buttonPanel.setLayout(new java.awt.GridBagLayout());

        buttonPanel.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(1, 5, 1, 10)));
        resetButton.setText(rb.getString("GUI.Find.Reset"));
        resetButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                resetButtonActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        buttonPanel.add(resetButton, gridBagConstraints);

        findButton.setText(rb.getString("GUI.Menu.Find"));
        findButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                findButtonActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        buttonPanel.add(findButton, gridBagConstraints);

        cancelButton.setText(rb.getString("GUI.General.Close"));
        cancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelButtonActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        buttonPanel.add(cancelButton, gridBagConstraints);

        getContentPane().add(buttonPanel, java.awt.BorderLayout.EAST);

        pack();
    }//GEN-END:initComponents

    private void sourceRadioButtonItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_sourceRadioButtonItemStateChanged
        // Add your handling code here:
        switchit();
    }//GEN-LAST:event_sourceRadioButtonItemStateChanged

    private void targetRadioButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_targetRadioButtonActionPerformed
        // Add your handling code here:
        //switchit();
    }//GEN-LAST:event_targetRadioButtonActionPerformed

    private void sourceRadioButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_sourceRadioButtonActionPerformed
        // Add your handling code here:
        //switchit();
    }//GEN-LAST:event_sourceRadioButtonActionPerformed

    private void findTextFieldKeyReleased(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_findTextFieldKeyReleased
      // Add your handling code here:
      if (evt.getKeyCode()==KeyEvent.VK_ENTER) {
          findButtonActionPerformed(null);
      } else
      if (evt.getKeyCode()==KeyEvent.VK_ESCAPE) {
          closeDialog(null);
      }
    }//GEN-LAST:event_findTextFieldKeyReleased

    private void resetButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_resetButtonActionPerformed
        // Add your handling code here:
         findTextField.setText("");
         next=0;
         findProgressBar.setValue(next);
         findTextField.requestFocus();
    }//GEN-LAST:event_resetButtonActionPerformed

    private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelButtonActionPerformed
        // Add your handling code here:
        closeDialog(null);
    }//GEN-LAST:event_cancelButtonActionPerformed

    private void findButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_findButtonActionPerformed
        // Add your handling code here:

        int found = main.findUnit(box, findTextField.getText(), next, matchUpperLowerCaseCheckBox.isSelected());
        if (found > -1) {
            box.setSelectedIndex(found);
            findProgressBar.setValue(found);
            next=found+1;
        }
        else {
            findProgressBar.setValue(findProgressBar.getMaximum());
            JOptionPane.showMessageDialog(this, rb.getString(
               (next==0)? "GUI.Find.UnitNotFoundInThisCategory":"GUI.Find.NoFurtherUnits"));
            next=0;
            findProgressBar.setValue(0);
        }
    }//GEN-LAST:event_findButtonActionPerformed

    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        setVisible(false);
        dispose();
    }//GEN-LAST:event_closeDialog

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        //new FindDialog(new javax.swing.JFrame(), true).show();
    }


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.ButtonGroup buttonGroup;
    private javax.swing.JPanel buttonPanel;
    private javax.swing.JButton cancelButton;
    private javax.swing.JButton findButton;
    private javax.swing.JLabel findLabel;
    private javax.swing.JPanel findPanel;
    private javax.swing.JProgressBar findProgressBar;
    private javax.swing.JTextField findTextField;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JCheckBox matchUpperLowerCaseCheckBox;
    private javax.swing.JButton resetButton;
    private javax.swing.JRadioButton sourceRadioButton;
    private javax.swing.JRadioButton targetRadioButton;
    // End of variables declaration//GEN-END:variables

}
