/******************************************************************************
 *
 * Numerical Chameleon version 1.6.0 - conversion tool
 * Copyright (C) 2001-2004  Dipl.-Inf. (FH) Johann Nepomuk Loefflmann,
 * All Rights Reserved, http://www.jonelo.de
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * e-Mail: jonelo@jonelo.de
 *
 *****************************************************************************/

package jonelo.NumericalChameleon.ListFormat;
import java.text.*;
import java.util.*;

public class DtcmListFormat extends ListFormat {

    private Format formatter;

    /** Creates a new instance of DtcmListFormat */
    public DtcmListFormat() {
        formatter = new SimpleDateFormat("MM/dd/yyyy");
    }

    // no header necessary
    public String getHeader() {
        return "";
    }

    // no footer necessary
    public String getFooter() {
        return "";
    }

    public String reformatDate(String date) throws ParseException {
       Date newdate = DateFormat.getDateInstance(DateFormat.MEDIUM).parse(date);
       return formatter.format(newdate);
    }

    public String getFormat() {
        return "\t** Calendar Appointment **\n\tDate: $TVALUE\n\tWhat: $TUNIT";
    }
}
