/******************************************************************************
 *
 * Numerical Chameleon version 1.6.0 - conversion tool
 * Copyright (C) 2001-2004  Dipl.-Inf. (FH) Johann Nepomuk Loefflmann,
 * All Rights Reserved, http://www.jonelo.de
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * e-Mail: jonelo@jonelo.de
 *
 *****************************************************************************/
package jonelo.NumericalChameleon.ListFormat;
import java.text.*;
import java.util.*;
import jonelo.sugar.util.*;

public class OutlookListFormat extends ListFormat {

    private Format formatter;
    private int count;

    /** Creates a new instance of OutlookListFormat */
    public OutlookListFormat() {
       formatter = new SimpleDateFormat("yyyy/MM/dd");
       count=0;
    }

    public String getHeader() {
        return "[NumericalChameleon] "+count+" \n";
    }

    // no footer necessary
    public String getFooter() {
        return "";
    }

    public String getFormat() {
        return "$TUNIT, $TVALUE";
    }

    public String reformatDate(String date) throws ParseException {
       Date newdate = DateFormat.getDateInstance(DateFormat.MEDIUM).parse(date);
       count++;
       return formatter.format(newdate);
    }

    public String reformatUnit(String unit) {
        String temp=GeneralString.replaceChar(unit,',',';');
        temp=GeneralString.replaceChar(temp,']',')');
        return GeneralString.replaceChar(temp,'[','(');
    }

/*
    public String getHeader() {
        "["+country+"] "+items+" \n";
    }

    public void setCountry(String country) {

    }

    public void setDay(String day) {

    }

    public String getTemplate() {
        Armed Forces Day, 1998/10/06
    }
  */
}
