/******************************************************************************
 *
 * Numerical Chameleon version 1.6.0 - conversion tool
 * Copyright (C) 2001-2004  Dipl.-Inf. (FH) Johann Nepomuk Loefflmann,
 * All Rights Reserved, http://www.jonelo.de
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * e-Mail: jonelo@jonelo.de
 *
 *****************************************************************************/

package jonelo.NumericalChameleon.MultipleNotice;
import java.math.BigDecimal;
import javax.swing.*;
import jonelo.sugar.gui.*;
import java.util.*;
import jonelo.NumericalChameleon.ListFormat.*;
import jonelo.sugar.util.GeneralProgram;
import java.awt.*;

public class MultipleNoticeDialog extends javax.swing.JDialog {

    private MultipleNoticeCluster multipleNoticeCluster;
    private ResourceBundle rb;

    /** Creates new form MultipleNoticesDialog */
    public MultipleNoticeDialog(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
    }

    public MultipleNoticeDialog(java.awt.Frame parent, boolean modal, MultipleNoticeCluster mnc,
       ResourceBundle rb) {
        super(parent, modal);
        this.rb=rb;
        this.multipleNoticeCluster=mnc;
        
        if (GeneralProgram.isSupportFor("1.4") && parent.isUndecorated()) {
            setUndecorated(true);
            getRootPane().setWindowDecorationStyle(JRootPane.FRAME);
        }
        
        initComponents();
        buttonGroup.add(oneTargetRadioButton);
        buttonGroup.add(multipleTargetsRadioButton);
        buttonGroup.add(allTargetsRadioButton);
        allTargetsRadioButton.setSelected(multipleNoticeCluster.getTargets() == MultipleNoticeCluster.ALL_TARGETS);
        multipleTargetsRadioButton.setSelected(multipleNoticeCluster.getTargets() == MultipleNoticeCluster.MULTIPLE_TARGETS);
        oneTargetRadioButton.setSelected(multipleNoticeCluster.getTargets() == MultipleNoticeCluster.ALL_TARGETS);
        startTextField.setText(mnc.getStartValue().toString());
        endTextField.setText(mnc.getEndValue().toString());
        stepTextField.setText(mnc.getStepValue().toString());

        if (!mnc.isListFormatVisible()) {
            listFormatPanel.setVisible(false);
            pack();
        }
        GeneralGUI.setLocationRelativeTo(this,parent);
        ComponentOrientation ce = ComponentOrientation.getOrientation(Locale.getDefault()); 
        if (!ce.isLeftToRight()) GeneralGUI.applyOrientation(listPanel, ce);        
        show();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        java.awt.GridBagConstraints gridBagConstraints;

        buttonGroup = new javax.swing.ButtonGroup();
        jPanel1 = new javax.swing.JPanel();
        listPanel = new javax.swing.JPanel();
        jPanel4 = new javax.swing.JPanel();
        startLabel = new javax.swing.JLabel();
        startTextField = new javax.swing.JTextField();
        endLabel = new javax.swing.JLabel();
        endTextField = new javax.swing.JTextField();
        stepLabel = new javax.swing.JLabel();
        stepTextField = new javax.swing.JTextField();
        jPanel5 = new javax.swing.JPanel();
        oneTargetRadioButton = new javax.swing.JRadioButton();
        multipleTargetsRadioButton = new javax.swing.JRadioButton();
        allTargetsRadioButton = new javax.swing.JRadioButton();
        jLabel1 = new javax.swing.JLabel();
        listFormatPanel = new javax.swing.JPanel();
        listFormatComboBox = new javax.swing.JComboBox();
        jLabel2 = new javax.swing.JLabel();
        jPanel3 = new javax.swing.JPanel();
        okButton = new javax.swing.JButton();
        cancelButton = new javax.swing.JButton();

        setTitle(rb.getString("GUI.List.Title"));
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });

        jPanel1.setLayout(new java.awt.BorderLayout());

        jPanel1.setBorder(new javax.swing.border.EtchedBorder());
        listPanel.setLayout(new java.awt.GridBagLayout());

        listPanel.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(5, 5, 5, 5)));
        jPanel4.setLayout(new java.awt.GridBagLayout());

        jPanel4.setBorder(new javax.swing.border.EtchedBorder());
        startLabel.setText(rb.getString("GUI.List.Start.Label"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 0, 3);
        jPanel4.add(startLabel, gridBagConstraints);

        startTextField.setPreferredSize(new java.awt.Dimension(200, 21));
        startTextField.setMinimumSize(new java.awt.Dimension(200, 21));
        startTextField.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyReleased(java.awt.event.KeyEvent evt) {
                startTextFieldKeyReleased(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 0, 5);
        jPanel4.add(startTextField, gridBagConstraints);

        endLabel.setText(rb.getString("GUI.List.End.Label"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 3);
        jPanel4.add(endLabel, gridBagConstraints);

        endTextField.setPreferredSize(new java.awt.Dimension(200, 21));
        endTextField.setMinimumSize(new java.awt.Dimension(200, 21));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 0, 5);
        jPanel4.add(endTextField, gridBagConstraints);

        stepLabel.setText(rb.getString("GUI.List.Step.Label"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 5, 3);
        jPanel4.add(stepLabel, gridBagConstraints);

        stepTextField.setPreferredSize(new java.awt.Dimension(200, 21));
        stepTextField.setMinimumSize(new java.awt.Dimension(200, 21));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 5, 5);
        jPanel4.add(stepTextField, gridBagConstraints);

        listPanel.add(jPanel4, new java.awt.GridBagConstraints());

        jPanel5.setLayout(new java.awt.GridBagLayout());

        jPanel5.setBorder(new javax.swing.border.EtchedBorder());
        oneTargetRadioButton.setSelected(true);
        oneTargetRadioButton.setText(rb.getString("GUI.List.CalculateForOneTarget.Label"));
        oneTargetRadioButton.setToolTipText("all target units");
        oneTargetRadioButton.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                oneTargetRadioButtonItemStateChanged(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel5.add(oneTargetRadioButton, gridBagConstraints);

        multipleTargetsRadioButton.setText(rb.getString("GUI.List.CalculateForMultipleTargets.Label"));
        multipleTargetsRadioButton.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                multipleTargetsRadioButtonItemStateChanged(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel5.add(multipleTargetsRadioButton, gridBagConstraints);

        allTargetsRadioButton.setText(rb.getString("GUI.List.CalculateForAllTargets.Label"));
        allTargetsRadioButton.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                allTargetsRadioButtonItemStateChanged(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel5.add(allTargetsRadioButton, gridBagConstraints);

        jLabel1.setText(rb.getString("GUI.List.CalculateFor.Label"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 0, 0);
        jPanel5.add(jLabel1, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        listPanel.add(jPanel5, gridBagConstraints);

        listFormatPanel.setLayout(new java.awt.GridBagLayout());

        listFormatPanel.setBorder(new javax.swing.border.EtchedBorder());
        listFormatComboBox.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Default", "dtcm (CDE)", "Outlook", "vCalendar" }));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        listFormatPanel.add(listFormatComboBox, gridBagConstraints);

        jLabel2.setText(rb.getString("GUI.List.Format.Label"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 0, 5);
        listFormatPanel.add(jLabel2, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        listPanel.add(listFormatPanel, gridBagConstraints);

        jPanel1.add(listPanel, java.awt.BorderLayout.CENTER);

        jPanel3.setLayout(new java.awt.GridBagLayout());

        jPanel3.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(1, 5, 5, 5)));
        okButton.setText("OK");
        okButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                okButtonActionPerformed(evt);
            }
        });

        jPanel3.add(okButton, new java.awt.GridBagConstraints());

        cancelButton.setText(rb.getString("GUI.General.Cancel"));
        cancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelButtonActionPerformed(evt);
            }
        });

        jPanel3.add(cancelButton, new java.awt.GridBagConstraints());

        jPanel1.add(jPanel3, java.awt.BorderLayout.SOUTH);

        getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);

        pack();
    }//GEN-END:initComponents

    private void multipleTargetsRadioButtonItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_multipleTargetsRadioButtonItemStateChanged
        // Add your handling code here:
        multipleNoticeCluster.setTargets(MultipleNoticeCluster.MULTIPLE_TARGETS);
    }//GEN-LAST:event_multipleTargetsRadioButtonItemStateChanged

    private void startTextFieldKeyReleased(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_startTextFieldKeyReleased
        // Add your handling code here:
        endTextField.setText(startTextField.getText());
    }//GEN-LAST:event_startTextFieldKeyReleased

    private void allTargetsRadioButtonItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_allTargetsRadioButtonItemStateChanged
        // Add your handling code here:
        multipleNoticeCluster.setTargets(MultipleNoticeCluster.ALL_TARGETS);
    }//GEN-LAST:event_allTargetsRadioButtonItemStateChanged

    private void oneTargetRadioButtonItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_oneTargetRadioButtonItemStateChanged
        // Add your handling code here:
        multipleNoticeCluster.setTargets(MultipleNoticeCluster.ONE_TARGET);
    }//GEN-LAST:event_oneTargetRadioButtonItemStateChanged

    private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelButtonActionPerformed
        // Add your handling code here:
        multipleNoticeCluster.setSuccess(false);
        closeDialog();
    }//GEN-LAST:event_cancelButtonActionPerformed

    private void okButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_okButtonActionPerformed
        // Add your handling code here:
        // check start, end and step value

        try {
            multipleNoticeCluster.setStartValue(new BigDecimal(startTextField.getText().trim()));
            multipleNoticeCluster.setEndValue(new BigDecimal(endTextField.getText().trim()));
            multipleNoticeCluster.setStepValue(new BigDecimal(stepTextField.getText().trim()));
            multipleNoticeCluster.setSuccess(true);
            if (multipleNoticeCluster.isListFormatVisible()) {
              if (listFormatComboBox.getSelectedItem().equals("dtcm (CDE)"))
                  multipleNoticeCluster.setListFormat(new DtcmListFormat());
              else
              if (listFormatComboBox.getSelectedItem().equals("Outlook"))
                  multipleNoticeCluster.setListFormat(new OutlookListFormat());
              else
              if (listFormatComboBox.getSelectedItem().equals("vCalendar"))
                  multipleNoticeCluster.setListFormat(new VCalendarListFormat());
              else
                  multipleNoticeCluster.setListFormat(null);
            }
            closeDialog();
        } catch (Exception e)
        {
            JOptionPane.showMessageDialog(this,"Number Format Error");
        }

    }//GEN-LAST:event_okButtonActionPerformed

    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        closeDialog();
    }//GEN-LAST:event_closeDialog

    private void closeDialog()
    {
        setVisible(false);
        dispose();
    }
    /**
    * @param args the command line arguments
    */
    public static void main(String args[]) {
        new MultipleNoticeDialog(new javax.swing.JFrame(), true).show();
    }


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JRadioButton allTargetsRadioButton;
    private javax.swing.ButtonGroup buttonGroup;
    private javax.swing.JButton cancelButton;
    private javax.swing.JLabel endLabel;
    private javax.swing.JTextField endTextField;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JComboBox listFormatComboBox;
    private javax.swing.JPanel listFormatPanel;
    private javax.swing.JPanel listPanel;
    private javax.swing.JRadioButton multipleTargetsRadioButton;
    private javax.swing.JButton okButton;
    private javax.swing.JRadioButton oneTargetRadioButton;
    private javax.swing.JLabel startLabel;
    private javax.swing.JTextField startTextField;
    private javax.swing.JLabel stepLabel;
    private javax.swing.JTextField stepTextField;
    // End of variables declaration//GEN-END:variables

}
