/******************************************************************************
 *
 * Numerical Chameleon version 1.6.0 - conversion tool
 * Copyright (C) 2001-2004  Dipl.-Inf. (FH) Johann Nepomuk Loefflmann,
 * All Rights Reserved, http://www.jonelo.de
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * e-Mail: jonelo@jonelo.de
 *
 *****************************************************************************/
package jonelo.NumericalChameleon;
import jonelo.sugar.util.GeneralString;
import java.math.*;
import javax.swing.*;
import java.net.*;
import java.io.*;

public class NcRecord implements Comparable, Serializable {

    private String string;
    private BigDecimal factor;
    private String icon;
    private String name;
    private boolean active;

    /** Creates new NcRecord */
    public NcRecord() {
    }

    public NcRecord(String string, String icon) {
        this.string=string;
        this.factor=null;
        setIcon(icon);
        this.name=null;
        this.active=true;
    }

    public NcRecord(String string, String icon, boolean active) {
        this.string=string;
        this.factor=null;
        setIcon(icon);
        this.name=null;
        this.active=active;
    }

    public NcRecord(String string, BigDecimal factor) {
        this.string=string;
        this.factor=factor;
        this.icon=null;
        this.name=null;
        this.active=true;
    }

    public NcRecord(String string, BigDecimal factor, String icon) {
        this.string=string;
        this.factor=factor;
        setIcon(icon);
        this.name=null;
        this.active=true;
    }

    public void setIcon(String icon) {
        this.icon = icon;
    }

    public void setActive(boolean active) {
        this.active=active;
    }

    public boolean getActive() {
        return active;
    }

    public void setName(String name) {
        this.name=name;
    }

    public String getName() {
        return name;
    }

    public String getString() {
        return string;
    }

    public String getText() {
        return string;
    }

    public BigDecimal getFactor() {
        return factor;
    }

    public String getIcon() {
        return icon;
    }

    public String toString() {
        return string;
    }

    public String toComparableString() {
        // for german umlauts
        String st = string.toLowerCase();
        st = GeneralString.replaceAllStrings(st, "", "oe");
        st = GeneralString.replaceAllStrings(st, "", "ae");
        st = GeneralString.replaceAllStrings(st, "", "ue");
        return st;
    }

    public int compareTo(Object obj) {
        return toComparableString().compareTo(((NcRecord)obj).toComparableString());
    }

}
