/******************************************************************************
 *
 * Numerical Chameleon version 1.6.0 - conversion tool
 * Copyright (C) 2001-2004  Dipl.-Inf. (FH) Johann Nepomuk Loefflmann,
 * All Rights Reserved, http://www.jonelo.de
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * e-Mail: jonelo@jonelo.de
 *
 *****************************************************************************/
package jonelo.NumericalChameleon;
import jonelo.NumericalChameleon.Main;
import javax.swing.*;
import java.awt.*;
import java.net.*;

public class NcRecordCellRenderer extends JLabel implements ListCellRenderer {
    private static Color
    LILA = new Color(0x9999CC),
    GRAY = new Color(0xCCCCCC),
    LIGHTGRAYDARKER = new Color(0x868686); // Color.lightGray.darker()

    public Component getListCellRendererComponent(
    JList list, Object value, int index,
    boolean isSelected, boolean cellHasFocus) {
        NcRecord ncr = (NcRecord)value;
        String iconCode = ncr.getIcon();
        setToolTipText((String)(Main.iso3166.getString( iconCode )));

        try {
            URL url = getClass().getResource(Main.IMAGE_DIR+"/flags/"+iconCode+".png");
            setIcon(new ImageIcon(url));
        } catch (Exception e) {}

        setText(ncr.getText());
        setForeground(ncr.getActive() ? Color.black : LIGHTGRAYDARKER);
        setBackground(isSelected ?  LILA : GRAY);
        setOpaque(isSelected);
        return this;
    }
}
