/******************************************************************************
 *
 * Numerical Chameleon version 1.6.0 - conversion tool
 * Copyright (C) 2001-2004  Dipl.-Inf. (FH) Johann Nepomuk Loefflmann,
 * All Rights Reserved, http://www.jonelo.de
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * e-Mail: jonelo@jonelo.de
 *
 *****************************************************************************/
package jonelo.NumericalChameleon.PhoneticAlphabetDialog;

import java.util.*;
import javax.swing.*;
import jonelo.sugar.gui.GeneralGUI;
import jonelo.NumericalChameleon.*;
import jonelo.sugar.util.GeneralProgram;


public class PhoneticAlphabetDialog extends javax.swing.JDialog {
    ResourceBundle rb;
    /** Creates new form PhoneticAlphabetDialog */
    public PhoneticAlphabetDialog(java.awt.Frame parent, boolean modal, ResourceBundle rb) {
        super(parent, modal);
        this.rb=rb;
        setTitle(rb.getString("GUI.PhoneticAlphabet.Title"));        
        if (GeneralProgram.isSupportFor("1.4") && parent.isUndecorated()) {
            setUndecorated(true);
            getRootPane().setWindowDecorationStyle(JRootPane.FRAME);
        }
        phoneticAlphabet = new PhoneticAlphabet(PhoneticAlphabet.INTERNATIONAL);
        initComponents();
        GeneralGUI.setLocationRelativeTo(this,parent);
        // 1.4+ only: setLocationRelativeTo(parent);

        inputTextField.requestFocus();
       // inputTextField.setText("enter text here");
       // inputTextField.selectAll();

        NcRecordCellRenderer ncRecordCellRenderer = new NcRecordCellRenderer();
        alphabetComboBox.setRenderer(ncRecordCellRenderer);
        show();
    }


    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        java.awt.GridBagConstraints gridBagConstraints;

        jPanel1 = new javax.swing.JPanel();
        alphabetLabel = new javax.swing.JLabel();
        textLabel = new javax.swing.JLabel();
        jPanel3 = new javax.swing.JPanel();
        alphabetComboBox = new javax.swing.JComboBox();
        jPanel4 = new javax.swing.JPanel();
        prevButton = new javax.swing.JButton();
        nextButton = new javax.swing.JButton();
        spellLabel = new javax.swing.JLabel();
        inputTextField = new javax.swing.JTextField();
        jScrollPane1 = new javax.swing.JScrollPane();
        wordList = new javax.swing.JList();
        jPanel2 = new javax.swing.JPanel();
        closeButton = new javax.swing.JButton();

        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });

        jPanel1.setLayout(new java.awt.GridBagLayout());

        jPanel1.setBorder(new javax.swing.border.BevelBorder(javax.swing.border.BevelBorder.RAISED));
        alphabetLabel.setText(rb.getString("GUI.PhoneticAlphabet.Alphabet"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel1.add(alphabetLabel, gridBagConstraints);

        textLabel.setText(rb.getString("GUI.PhoneticAlphabet.Text"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 5);
        jPanel1.add(textLabel, gridBagConstraints);

        jPanel3.setLayout(new java.awt.GridBagLayout());

        alphabetComboBox.setMaximumRowCount(19);
        alphabetComboBox.setModel(getAlphabetModel());
        alphabetComboBox.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                alphabetComboBoxItemStateChanged(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel3.add(alphabetComboBox, gridBagConstraints);

        jPanel4.setLayout(new java.awt.GridLayout(2, 0));

        prevButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/core/images/main/up3.gif")));
        prevButton.setMargin(new java.awt.Insets(2, 2, 2, 2));
        prevButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                prevButtonActionPerformed(evt);
            }
        });

        jPanel4.add(prevButton);

        nextButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/core/images/main/down3.gif")));
        nextButton.setMargin(new java.awt.Insets(2, 2, 2, 2));
        nextButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                nextButtonActionPerformed(evt);
            }
        });

        jPanel4.add(nextButton);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        jPanel3.add(jPanel4, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 5, 5);
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel1.add(jPanel3, gridBagConstraints);

        spellLabel.setText(rb.getString("GUI.PhoneticAlphabet.Spell"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        jPanel1.add(spellLabel, gridBagConstraints);

        inputTextField.setPreferredSize(new java.awt.Dimension(200, 20));
        inputTextField.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyReleased(java.awt.event.KeyEvent evt) {
                inputTextFieldKeyReleased(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 0, 5);
        jPanel1.add(inputTextField, gridBagConstraints);

        jScrollPane1.setPreferredSize(new java.awt.Dimension(300, 300));
        wordList.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
        jScrollPane1.setViewportView(wordList);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 5, 5);
        jPanel1.add(jScrollPane1, gridBagConstraints);

        getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);

        closeButton.setText(rb.getString("GUI.General.Close"));
        closeButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                closeButtonActionPerformed(evt);
            }
        });

        jPanel2.add(closeButton);

        getContentPane().add(jPanel2, java.awt.BorderLayout.SOUTH);

        pack();
    }//GEN-END:initComponents

    private void nextButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_nextButtonActionPerformed
        // Add your handling code here:
      int now = alphabetComboBox.getSelectedIndex();
      int all = alphabetComboBox.getItemCount();
      if (now+1 < all) alphabetComboBox.setSelectedIndex(now+1); else alphabetComboBox.setSelectedIndex(0);
    }//GEN-LAST:event_nextButtonActionPerformed

    private void prevButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_prevButtonActionPerformed
        // Add your handling code here:
      int now = alphabetComboBox.getSelectedIndex();
      int all = alphabetComboBox.getItemCount();
      if (now > 0) alphabetComboBox.setSelectedIndex(now-1); else alphabetComboBox.setSelectedIndex(all-1);
    }//GEN-LAST:event_prevButtonActionPerformed

    private void alphabetComboBoxItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_alphabetComboBoxItemStateChanged
        // Add your handling code here:
     // load a new alphabet into spell
     phoneticAlphabet = new PhoneticAlphabet(getAlphabet(alphabetComboBox.getSelectedIndex()));
     updateWordsList();
    }//GEN-LAST:event_alphabetComboBoxItemStateChanged

    private void inputTextFieldKeyReleased(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_inputTextFieldKeyReleased
        // Add your handling code here:
      int code = evt.getKeyCode();
      boolean b = true;
      for (int i=0; i < GeneralGUI.noTextChangeKeyEvents.length; i++) {
          if (code == GeneralGUI.noTextChangeKeyEvents[i]) { b=false; break; }
      }
      if (b) updateWordsList();
    }//GEN-LAST:event_inputTextFieldKeyReleased

    private void closeButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_closeButtonActionPerformed
        // Add your handling code here:
        closeDialog(null);
    }//GEN-LAST:event_closeButtonActionPerformed

    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        setVisible(false);
        dispose();
    }//GEN-LAST:event_closeDialog

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        new PhoneticAlphabetDialog(new javax.swing.JFrame(), true,null).show();
    }


    //**************
    // phoneticAlphabet-methods

    private javax.swing.ComboBoxModel getAlphabetModel()
    {
        Vector data = new Vector();
        data.add(new NcRecord(PhoneticAlphabet.INTERNATIONAL_NAME, "int"));
        data.add(new NcRecord(PhoneticAlphabet.MORSE_NAME, "int"));
        data.add(new NcRecord(PhoneticAlphabet.NATO_NAME, "int"));
        data.add(new NcRecord(PhoneticAlphabet.AMERICAN_NAME, "us"));
        data.add(new NcRecord(PhoneticAlphabet.BRITISH_NAME, "gb"));
        data.add(new NcRecord(PhoneticAlphabet.FRENCH_NAME, "fr"));
        data.add(new NcRecord(PhoneticAlphabet.SPAIN_NAME, "es"));
        data.add(new NcRecord(PhoneticAlphabet.GERMAN_NAME, "de"));
        data.add(new NcRecord(PhoneticAlphabet.ITALIAN_NAME, "it"));
        data.add(new NcRecord(PhoneticAlphabet.PORTUGUESE_NAME, "pt"));
        data.add(new NcRecord(PhoneticAlphabet.DANISH_NAME, "dk"));
        data.add(new NcRecord(PhoneticAlphabet.DUTCH_NAME, "nl"));
        data.add(new NcRecord(PhoneticAlphabet.SWEDISH_NAME,"se"));
        data.add(new NcRecord(PhoneticAlphabet.HEBREW_NAME,"il"));

        data.add(new NcRecord(PhoneticAlphabet.ARMYNAVY_NAME, "us",false));
        data.add(new NcRecord(PhoneticAlphabet.RAF_1943_1956_NAME, "gb",false));
        data.add(new NcRecord(PhoneticAlphabet.RAF_1942_1943_NAME, "gb",false));
        data.add(new NcRecord(PhoneticAlphabet.RAF_1924_1942_NAME, "gb",false));
        data.add(new NcRecord(PhoneticAlphabet.ROYAL_NAVY_NAME, "gb", false));

      javax.swing.JComboBox cb = new javax.swing.JComboBox(data);
      return cb.getModel();
    }

    private void updateWordsList()
    {
      wordList.removeAll();
      wordList.setModel(getWordsModel( phoneticAlphabet.get(inputTextField.getText()) ));
    }

    private ListModel getWordsModel(Vector v)
    {
      javax.swing.JList jl = new javax.swing.JList(v);
      return jl.getModel();
    }

    private String[] getAlphabet(int i)
    {
       switch (i)
       {
           case  0: return PhoneticAlphabet.INTERNATIONAL;
           case  1: return PhoneticAlphabet.MORSE;
           case  2: return PhoneticAlphabet.NATO;
           case  3: return PhoneticAlphabet.AMERICAN;
           case  4: return PhoneticAlphabet.BRITISH;
           case  5: return PhoneticAlphabet.FRENCH;
           case  6: return PhoneticAlphabet.SPANISH;
           case  7: return PhoneticAlphabet.GERMAN;
           case  8: return PhoneticAlphabet.ITALIAN;
           case  9: return PhoneticAlphabet.PORTUGUESE;
           case 10: return PhoneticAlphabet.DANISH;
           case 11: return PhoneticAlphabet.DUTCH;
           case 12: return PhoneticAlphabet.SWEDISH;
           case 13: return PhoneticAlphabet.HEBREW;

           case 14: return PhoneticAlphabet.ARMYNAVY;
           case 15: return PhoneticAlphabet.RAF_1943_1956;
           case 16: return PhoneticAlphabet.RAF_1942_1943;
           case 17: return PhoneticAlphabet.RAF_1924_1942;
           case 18: return PhoneticAlphabet.BRITISH_ROYAL_NAVY;
       }
       return null;
    }



    // Non generated variables declaration
    private PhoneticAlphabet phoneticAlphabet;



    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JComboBox alphabetComboBox;
    private javax.swing.JLabel alphabetLabel;
    private javax.swing.JButton closeButton;
    private javax.swing.JTextField inputTextField;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JButton nextButton;
    private javax.swing.JButton prevButton;
    private javax.swing.JLabel spellLabel;
    private javax.swing.JLabel textLabel;
    private javax.swing.JList wordList;
    // End of variables declaration//GEN-END:variables

}
