/******************************************************************************
 *
 * Numerical Chameleon version 1.6.0 - conversion tool
 * Copyright (C) 2001-2004  Dipl.-Inf. (FH) Johann Nepomuk Loefflmann,
 * All Rights Reserved, http://www.jonelo.de
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * e-Mail: jonelo@jonelo.de
 *
 *****************************************************************************/

package jonelo.NumericalChameleon.PropsDialog;
import jonelo.NumericalChameleon.Main;
import jonelo.sugar.util.GeneralString;
import javax.swing.event.*;
import javax.swing.tree.*;
import javax.swing.*;
import java.util.*;
import jonelo.sugar.gui.GeneralGUI;
import jonelo.sugar.util.GeneralProgram;
import java.awt.*;

public class PropsDialog extends javax.swing.JDialog {

    public static final String
    TRUE = "true",
    FALSE = "false";

    ResourceBundle rb;
    Properties props;    
    /** Creates new form PropsDialog */
    public PropsDialog(java.awt.Frame parent, boolean modal, ResourceBundle rb, Properties props) {
        super(parent, modal);
        this.rb = rb;
        this.props = props;
        if (GeneralProgram.isSupportFor("1.4") && parent.isUndecorated()) {
            setUndecorated(true);
            getRootPane().setWindowDecorationStyle(JRootPane.FRAME);
        }
        setTitle(rb.getString("GUI.Options.Title"));
        initComponents();
        if (GeneralProgram.isSupportFor("1.4")) {
            if ( props.getProperty("lnf","").equals("kunststoff") ||
                 props.getProperty("lnf","").equals("metal") ||
                 props.getProperty("lnf","").equals("metal_default") ||
                 props.getProperty("lnf","").equals("metal_ocean") ||
                 props.getProperty("lnf","").equals("plastic") ||
                 props.getProperty("lnf","").equals("metouia") ||
                 props.getProperty("lnf","").equals("squareness")
            ) {
              // option is only supported by Java based Look and Feels
              frameDecorationCheckBox.setEnabled(true);   
            } else
              // frameDecorationCheckBox is disabled already by default
              props.setProperty("lnf", "native");
        }                   
        if (Main.isOrientationRightToLeft()) 
            GeneralGUI.applyOrientation(centerPanel, ComponentOrientation.RIGHT_TO_LEFT);
        // modify components
        restore();
        GeneralGUI.setLocationRelativeTo(this,parent);
    }

    public void restore()
    {
        //splashCheckBox.setSelected(props.getProperty("splashscreen","true").equals("true"));
        frameDecorationCheckBox.setSelected(props.getProperty("decoration","native").equals("java"));
        showToolTipsCheckBox.setSelected(props.getProperty("tooltips","true").equals("true"));
        try {
          toolTipSlider.setValue(Integer.parseInt(props.getProperty("tooltips.delay","750")));
        } catch (NumberFormatException nfe) {}
        setShowToolTipsCheckBoxText();
        askBeforeExitCheckBox.setSelected(props.getProperty("askBeforeExit","true").equals("true"));
        // showExitAnimationCheckBox.setSelected(props.getProperty("exitAnimation","false").equals("true"));
    }


    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        java.awt.GridBagConstraints gridBagConstraints;

        jPanel5 = new javax.swing.JPanel();
        southPanel = new javax.swing.JPanel();
        buttonPanel = new javax.swing.JPanel();
        okButton = new javax.swing.JButton();
        restoreButton = new javax.swing.JButton();
        cancelButton = new javax.swing.JButton();
        centerPanel = new javax.swing.JPanel();
        jTabbedPane1 = new javax.swing.JTabbedPane();
        generalOptions = new javax.swing.JPanel();
        startOptionsLabel = new javax.swing.JLabel();
        jSeparator1 = new javax.swing.JSeparator();
        frameDecorationCheckBox = new javax.swing.JCheckBox();
        runningOptionsLabel = new javax.swing.JLabel();
        jSeparator2 = new javax.swing.JSeparator();
        showToolTipsCheckBox = new javax.swing.JCheckBox();
        exitOptionsLabel = new javax.swing.JLabel();
        jSeparator3 = new javax.swing.JSeparator();
        askBeforeExitCheckBox = new javax.swing.JCheckBox();
        jPanel1 = new javax.swing.JPanel();
        toolTipDelayLabel = new javax.swing.JLabel();
        toolTipSlider = new javax.swing.JSlider();

        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });

        jPanel5.setLayout(new java.awt.BorderLayout());

        jPanel5.setMinimumSize(new java.awt.Dimension(500, 400));
        jPanel5.setPreferredSize(new java.awt.Dimension(500, 400));
        southPanel.setLayout(new java.awt.BorderLayout());

        okButton.setText("OK");
        okButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                okButtonActionPerformed(evt);
            }
        });

        buttonPanel.add(okButton);

        restoreButton.setText(rb.getString("GUI.General.Restore"));
        restoreButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                restoreButtonActionPerformed(evt);
            }
        });

        buttonPanel.add(restoreButton);

        cancelButton.setText(rb.getString("GUI.General.Cancel"));
        cancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelButtonActionPerformed(evt);
            }
        });

        buttonPanel.add(cancelButton);

        southPanel.add(buttonPanel, java.awt.BorderLayout.EAST);

        jPanel5.add(southPanel, java.awt.BorderLayout.SOUTH);

        centerPanel.setLayout(new java.awt.BorderLayout());

        centerPanel.setBorder(new javax.swing.border.EtchedBorder());
        centerPanel.setMinimumSize(new java.awt.Dimension(100, 99));
        centerPanel.setPreferredSize(new java.awt.Dimension(100, 99));
        generalOptions.setLayout(new java.awt.GridBagLayout());

        generalOptions.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(10, 10, 10, 10)));
        startOptionsLabel.setFont(new java.awt.Font("Dialog", 1, 14));
        startOptionsLabel.setText(rb.getString("GUI.Options.StartOptions"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        generalOptions.add(startOptionsLabel, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        generalOptions.add(jSeparator1, gridBagConstraints);

        frameDecorationCheckBox.setText(rb.getString("GUI.Options.FrameDecoration"));
        frameDecorationCheckBox.setToolTipText(rb.getString("GUI.Options.RequiresManualRestart"));
        frameDecorationCheckBox.setEnabled(false);
        frameDecorationCheckBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                frameDecorationCheckBoxActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        generalOptions.add(frameDecorationCheckBox, gridBagConstraints);

        runningOptionsLabel.setFont(new java.awt.Font("Dialog", 1, 14));
        runningOptionsLabel.setText(rb.getString("GUI.Options.RuntimeOptions"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(10, 0, 0, 0);
        generalOptions.add(runningOptionsLabel, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        generalOptions.add(jSeparator2, gridBagConstraints);

        showToolTipsCheckBox.setText(rb.getString("GUI.Options.ShowToolTips"));
        showToolTipsCheckBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                showToolTipsCheckBoxActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        generalOptions.add(showToolTipsCheckBox, gridBagConstraints);

        exitOptionsLabel.setFont(new java.awt.Font("Dialog", 1, 14));
        exitOptionsLabel.setText(rb.getString("GUI.Options.ExitOptions"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 8;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(10, 0, 0, 0);
        generalOptions.add(exitOptionsLabel, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 9;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        generalOptions.add(jSeparator3, gridBagConstraints);

        askBeforeExitCheckBox.setText(rb.getString("GUI.Options.AskBeforeExit"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 10;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        generalOptions.add(askBeforeExitCheckBox, gridBagConstraints);

        jPanel1.setLayout(new java.awt.BorderLayout());

        toolTipDelayLabel.setText(rb.getString("GUI.Options.TooltipDelayInMs"));
        jPanel1.add(toolTipDelayLabel, java.awt.BorderLayout.WEST);

        toolTipSlider.setMajorTickSpacing(500);
        toolTipSlider.setMaximum(3000);
        toolTipSlider.setPaintTicks(true);
        toolTipSlider.setValue(750);
        toolTipSlider.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                toolTipSliderStateChanged(evt);
            }
        });

        jPanel1.add(toolTipSlider, java.awt.BorderLayout.EAST);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        generalOptions.add(jPanel1, gridBagConstraints);

        jTabbedPane1.addTab(rb.getString("GUI.Options.General"), generalOptions);

        centerPanel.add(jTabbedPane1, java.awt.BorderLayout.CENTER);

        jPanel5.add(centerPanel, java.awt.BorderLayout.CENTER);

        getContentPane().add(jPanel5, java.awt.BorderLayout.CENTER);

        pack();
    }//GEN-END:initComponents

    private void frameDecorationCheckBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_frameDecorationCheckBoxActionPerformed
        // Add your handling code here:
        JOptionPane.showMessageDialog(this,rb.getString("GUI.Options.FrameDecorationMessage"),
        rb.getString("GUI.Options.FrameDecoration"), JOptionPane.INFORMATION_MESSAGE);
    }//GEN-LAST:event_frameDecorationCheckBoxActionPerformed

    private void showToolTipsCheckBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_showToolTipsCheckBoxActionPerformed
        // Add your handling code here:
        toolTipSlider.setValue(750);
    }//GEN-LAST:event_showToolTipsCheckBoxActionPerformed

    private void toolTipSliderStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_toolTipSliderStateChanged
        // Add your handling code here:
        setShowToolTipsCheckBoxText();
    }//GEN-LAST:event_toolTipSliderStateChanged

    // set the text for the CheckBox showToolTipsCheckBox
    private void setShowToolTipsCheckBoxText()
    {
        int x = toolTipSlider.getValue();
        if (toolTipSlider.getValue() == 0) {
           showToolTipsCheckBox.setText(rb.getString("GUI.Options.ShowTooltipsImmediately"));
        } else {
           showToolTipsCheckBox.setText(
           GeneralString.message(rb.getString("GUI.Options.ShowTooltipsAfterXms"),toolTipSlider.getValue()));
        }
    }

    private void restoreButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_restoreButtonActionPerformed
        // Add your handling code here:
        restore();
    }//GEN-LAST:event_restoreButtonActionPerformed

    private void okButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_okButtonActionPerformed
        // Add your handling code here:
//        props.setProperty("splashscreen",splashCheckBox.isSelected()? TRUE:FALSE);
        props.setProperty("decoration", frameDecorationCheckBox.isSelected()?"java":"native");
        props.setProperty("tooltips", showToolTipsCheckBox.isSelected()?TRUE:FALSE);
        props.setProperty("askBeforeExit", askBeforeExitCheckBox.isSelected()?TRUE:FALSE);
        //props.setProperty("exitAnimation", showExitAnimationCheckBox.isSelected()?TRUE:FALSE);
        props.setProperty("tooltips.delay", Integer.toString(toolTipSlider.getValue()));
        props.setProperty("save", "true");
        // set OptionsObject
        closeDialog(null);
    }//GEN-LAST:event_okButtonActionPerformed

    private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelButtonActionPerformed
        // Add your handling code here:
        closeDialog(null);
    }//GEN-LAST:event_cancelButtonActionPerformed

    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        setVisible(false);
        dispose();
    }//GEN-LAST:event_closeDialog

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        //new PropsDialog(new javax.swing.JFrame(), true).show();
    }


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JCheckBox askBeforeExitCheckBox;
    private javax.swing.JPanel buttonPanel;
    private javax.swing.JButton cancelButton;
    private javax.swing.JPanel centerPanel;
    private javax.swing.JLabel exitOptionsLabel;
    private javax.swing.JCheckBox frameDecorationCheckBox;
    private javax.swing.JPanel generalOptions;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JSeparator jSeparator2;
    private javax.swing.JSeparator jSeparator3;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JButton okButton;
    private javax.swing.JButton restoreButton;
    private javax.swing.JLabel runningOptionsLabel;
    private javax.swing.JCheckBox showToolTipsCheckBox;
    private javax.swing.JPanel southPanel;
    private javax.swing.JLabel startOptionsLabel;
    private javax.swing.JLabel toolTipDelayLabel;
    private javax.swing.JSlider toolTipSlider;
    // End of variables declaration//GEN-END:variables


}
