/******************************************************************************
 *
 * Numerical Chameleon version 1.6.0 - conversion tool
 * Copyright (C) 2001-2004  Dipl.-Inf. (FH) Johann Nepomuk Loefflmann,
 * All Rights Reserved, http://www.jonelo.de
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * e-Mail: jonelo@jonelo.de
 *
 *****************************************************************************/
package jonelo.NumericalChameleon;
import java.math.*;
import javax.swing.*;
import java.net.*;

public class SectionRecord {

    private String string;
    private ImageIcon icon;
    private String name;
    private int figures=-1; // -1 = n/a
    private boolean logic;

    /** Creates new SectionRecord */
    public SectionRecord() {
    }

    public SectionRecord(String string, String icon)
    {
        this.string=string;
        setIcon(icon);
        this.name=null;
        this.logic = true;
    }

    public SectionRecord(String string, BigDecimal factor)
    {
        this.string=string;
        this.icon=null;
        this.name=null;
        this.logic = true;
    }

    public SectionRecord(String string, BigDecimal factor, String icon)
    {
        this.string=string;
        setIcon(icon);
        this.name=null;
        this.logic = true;
    }

    public void setIcon(String icon)
    {
        URL url = null;
        this.icon = null;
        try {
            url = getClass().getResource(icon);
            this.icon = new ImageIcon(url);
        } catch (Exception e) {}
    }

    public void setName(String name)
    {
        this.name=name;
    }

    public String getName()
    {
        return name;
    }

    public void setString(String string)
    {
        this.string=string;
    }

    public String getString()
    {
        return string;
    }

    public void setFigures(int figures)
    {
        this.figures=figures;
    }

    public int getFigures()
    {
        return figures;
    }

    public void setLogic(boolean logic)
    {
        this.logic=logic;
    }

    public boolean getLogic()
    {
        return logic;
    }

    public String getText()
    {
        return string;
    }

    public ImageIcon getIcon()
    {
        return icon;
    }
}
