/******************************************************************************
 *
 * Numerical Chameleon version 1.6.0 - conversion tool
 * Copyright (C) 2001-2004  Dipl.-Inf. (FH) Johann Nepomuk Loefflmann,
 * All Rights Reserved, http://www.jonelo.de
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * e-Mail: jonelo@jonelo.de
 *
 *****************************************************************************/
package jonelo.NumericalChameleon.SpokenNumbers;
import java.math.*;
public class KlingonNumber extends SpokenNumber
{

  protected static final String field[] =
  { "wa'","cha'","wej","loS","vagh","jav","Soch","chorgh","Hut" };
  protected static final String

  amount[] = {   "maH ", /* ten 10 */
               "vatlh ", /* hundred 100 */
                 "SaD ", /* thousand 1000*/
               "netlh ", /* ten thousand 10000 */
                 "bIp ", /*  hundred thousand 100000 */
                "'uy' "}, /* million 1000000 */



   NULL       = "pagh",
   MINUS      = "-",
   BLANK      = " ",
   DASH       = "-";


  public KlingonNumber() {
      super();
  }

  public KlingonNumber(long number) throws Exception {
      super(number);
  }

  public KlingonNumber(String number) throws Exception {
     super (number);
  }


  public String getSoundDir() {
      return "klingon";
  }


  /**
   * gibt Nummer in US-englischen Worten zurck.
   * @param number die zu konvertierende Zahl
   */
  public static String toString(long number) throws Exception {
    return (new KlingonNumber(number)).toString();
  }

  public static String toString(String number) throws Exception {
    return (new KlingonNumber(number)).toString();
  }

  protected void convert2Syllables() throws Exception {
    number2digits();
    if (number.charAt(0) == '-') {
       number=number.substring(1);
       syllables.addElement(MINUS);
    }

    // die Zahlentriple abarbeiten
    if (number.equals("0")) syllables.addElement(NULL); else {
      for (int i=getSupportedDigits()-1; i > 0 ; i--) { // all index
         if (digits[i] > 0) {
           syllables.addElement(field[digits[i]-1]);
           syllables.addElement(amount[i-1]);
         }
      }
      if (digits[0] > 0) syllables.addElement(field[digits[0]-1]);
    }
  }

  protected int getSupportedDigits() {
      return 7;
  }

}
