/******************************************************************************
 *
 * Numerical Chameleon version 1.6.0 - conversion tool
 * Copyright (C) 2001-2004  Dipl.-Inf. (FH) Johann Nepomuk Loefflmann,
 * All Rights Reserved, http://www.jonelo.de
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * e-Mail: jonelo@jonelo.de
 *
 *****************************************************************************/
package jonelo.NumericalChameleon.SpokenNumbers;
import jonelo.NumericalChameleon.PhoneticAlphabetDialog.PhoneticAlphabet;
import java.util.*;
public class MorseCodeNumber extends SpokenNumber {

    private PhoneticAlphabet phoneticAlphabet;

    /** Creates a new instance of MorseCodeNumber */
    public MorseCodeNumber() {
        super();
        phoneticAlphabet = new PhoneticAlphabet(PhoneticAlphabet.MORSE);
    }

    protected void convert2Syllables() throws Exception {
      if (number.charAt(0) == '-') {
        number=number.substring(1);
        syllables.addElement(phoneticAlphabet.get('-'));
      }

      if (number.equals("0")) syllables.addElement(phoneticAlphabet.get('0')); else {
        for (int i=0; i < number.length(); i++) {
          String temp = phoneticAlphabet.get(number.charAt(i));
          syllables.addElement(temp);
        }
      }
    }

    public String getSoundDir() {
        return "morse";
    }

    protected int getSupportedDigits() {
        return 1000; // should be enough
    }

  public void play()
  {

    Vector playvec = new Vector();
    int x=0;
    for (int i=0; i < syllables.size(); i++) {
          String temp = (String)(syllables.get(i));
          for (x=0; x < temp.length(); x++) {
              if (temp.charAt(x)=='.')
                  playvec.addElement("dot"); else
                  playvec.addElement("dash");
          }
    }


    if (audioThread!=null) { // stop any old threads
       audioThread.interrupt();
       while (audioThread.isAlive()) {
          // wait for a while
           try {
              Thread.sleep(1);
           } catch (InterruptedException e) {}
       }
    }
    audioThread = new AudioThread(playvec,getSoundDir());
    audioThread.start();
  }


}
