/******************************************************************************
 *
 * Numerical Chameleon version 1.6.0 - conversion tool
 * Copyright (C) 2001-2004  Dipl.-Inf. (FH) Johann Nepomuk Loefflmann,
 * All Rights Reserved, http://www.jonelo.de
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * e-Mail: jonelo@jonelo.de
 *
 *****************************************************************************/
package jonelo.NumericalChameleon.SpokenNumbers;
import java.math.*;
public class USEnglishNumber extends UKEnglishNumber
{

  protected static final String

  usamount[] =
  {"thousand",
   "million", "billion",
   "trillion", "quadrillion",
   "quintillion", "sextillion",
   "septillion", "octillion",
   "nonillion", "decillion",
   "undecillion", "duodecillion",
   "tredecillion", "quattuordecillion",
   "quindecillion", "sexdecillion",
   "septendecillon", "octodecillion",
   "novemdecillion", "vigintillion",
   "unvigintillion", "dovigintillion",
   "trevigintillion", "quattuorvigintillion",
   "quinvigintillion", "sexvigintillion",
   "septenvigintillion", "octovigintillion",
   "novemvigintillion", "trigintillion"
  };


  public USEnglishNumber() {
      super();
      amount=usamount;
  }

  public USEnglishNumber(long number) throws Exception {
      super(number);
      amount=usamount;
  }

  public USEnglishNumber(String number) throws Exception {
     super (number);
     amount=usamount;
  }


  public String getSoundDir() {
	  return "us_english";
  }

  protected void triple(int index)
  {
    if (digits[index+2] > 0)
    {
      syllables.addElement(field[0][digits[index+2]-1]);
      syllables.addElement(HUNDRED);
    }

    // no "AND" for integer values

    if ((digits[index+1] == 1) && (digits[index] > 0))         // XXXX11
    {
      syllables.addElement(field[1][digits[index]-1]);   // elf, zwlf, ...
    } else
    if ((digits[index+1] >= 1) && (digits[index] == 0))        // XXXX10
    {
      syllables.addElement(field[2][digits[index+1]-1]);   // zehn, zwanzig, ...
    } else                                                 // XXXX2X oder XXXX0X
    {
      if (digits[index+1] > 0)                                  // XXXX2X
      {
        syllables.addElement(field[2][digits[index+1]-1]); // zehn, zwanzig,...
        if (digits[index] > 0)                                // XXXX21
        {
          syllables.addElement("-");                            // und
        }
      }

      if (digits[index] > 0)                                  // XXXX21
      {
        syllables.addElement(field[0][digits[index]-1]); // ein, zwei, drei, ...
      }
    }
  }

  /**
   * gibt Nummer in US-englischen Worten zurck.
   * @param number die zu konvertierende Zahl
   */
  public static String toString(long number) throws Exception
  {
    return (new USEnglishNumber(number)).toString();
  }

  public static String toString(String number) throws Exception
  {
    return (new USEnglishNumber(number)).toString();
  }

}
