/******************************************************************************
 *
 * Sugar for Java 1.2.0
 * Copyright (C) 2001-2004  Dipl.-Inf. (FH) Johann Nepomuk Loefflmann,
 * All Rights Reserved, http://www.jonelo.de
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * @author jonelo@jonelo.de
 *
 *****************************************************************************/


package jonelo.sugar.gui;
import java.io.*;
import javax.swing.ImageIcon;

public class AboutDialog extends javax.swing.JDialog {

    public static String
     OK = "OK",
     THANKS = "Thanks",
     LICENSE = "License",
     ABOUT = "About";

    /** Creates new form AboutDialog */
    public AboutDialog(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        this.setVisible(false);
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        mainPanel = new javax.swing.JPanel();
        myTabbedPane = new javax.swing.JTabbedPane();
        aboutPanel = new javax.swing.JPanel();
        jPanel1 = new javax.swing.JPanel();
        jPanel3 = new javax.swing.JPanel();
        imageLabel = new javax.swing.JLabel();
        licensePanel = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        licenseEditorPane = new javax.swing.JEditorPane();
        try {
            licenseEditorPane.setContentType("text/html");
            licenseEditorPane.setText(license);
        } catch (Exception e) {}
        thanksPanel = new javax.swing.JPanel();
        jScrollPane2 = new javax.swing.JScrollPane();
        thanksEditorPane = new javax.swing.JEditorPane();
        try {
            thanksEditorPane.setContentType("text/html");
            thanksEditorPane.setText(thanks);
        } catch (Exception e) { System.err.println(e); }
        okPanel = new javax.swing.JPanel();
        okButton = new javax.swing.JButton();

        setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));
        setModal(true);
        setBackground(java.awt.Color.white);
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });

        mainPanel.setLayout(new java.awt.BorderLayout());

        aboutPanel.setLayout(new java.awt.BorderLayout());

        aboutPanel.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(10, 10, 10, 10)));
        jPanel1.setLayout(new java.awt.BorderLayout());

        jPanel1.setBorder(new javax.swing.border.EtchedBorder());
        jPanel3.setLayout(new java.awt.BorderLayout());

        imageLabel.setIcon(icon);
        imageLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        imageLabel.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(0, 0, 0, 0)));
        imageLabel.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                imageLabelMouseClicked(evt);
            }
        });

        jPanel3.add(imageLabel, java.awt.BorderLayout.CENTER);

        jPanel1.add(jPanel3, java.awt.BorderLayout.CENTER);

        aboutPanel.add(jPanel1, java.awt.BorderLayout.CENTER);

        myTabbedPane.addTab(ABOUT, aboutPanel);

        licensePanel.setLayout(new java.awt.BorderLayout());

        licensePanel.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(10, 10, 10, 10)));
        jScrollPane1.setPreferredSize(new java.awt.Dimension(390, 400));
        jScrollPane1.setMinimumSize(new java.awt.Dimension(390, 400));
        jScrollPane1.setFont(new java.awt.Font("Dialog", 0, 10));
        licenseEditorPane.setEditable(false);
        jScrollPane1.setViewportView(licenseEditorPane);

        licensePanel.add(jScrollPane1, java.awt.BorderLayout.CENTER);

        myTabbedPane.addTab(LICENSE, licensePanel);

        thanksPanel.setLayout(new java.awt.BorderLayout());

        thanksPanel.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(10, 10, 10, 10)));
        jScrollPane2.setPreferredSize(new java.awt.Dimension(390, 400));
        jScrollPane2.setMinimumSize(new java.awt.Dimension(390, 400));
        jScrollPane2.setFont(new java.awt.Font("Dialog", 0, 10));
        thanksEditorPane.setEditable(false);
        jScrollPane2.setViewportView(thanksEditorPane);

        thanksPanel.add(jScrollPane2, java.awt.BorderLayout.CENTER);

        myTabbedPane.addTab(THANKS, thanksPanel);

        mainPanel.add(myTabbedPane, java.awt.BorderLayout.CENTER);

        getContentPane().add(mainPanel, java.awt.BorderLayout.CENTER);

        okPanel.setLayout(new java.awt.BorderLayout());

        okButton.setText(OK);
        okButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                okButtonActionPerformed(evt);
            }
        });

        okPanel.add(okButton, java.awt.BorderLayout.CENTER);

        getContentPane().add(okPanel, java.awt.BorderLayout.SOUTH);

        pack();
    }//GEN-END:initComponents

    private void imageLabelMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_imageLabelMouseClicked
        // Add your handling code here:
        myTabbedPane.setSelectedIndex(1);
    }//GEN-LAST:event_imageLabelMouseClicked

    private void okButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_okButtonActionPerformed
        // Add your handling code here:
        setVisible(false);
        dispose();
    }//GEN-LAST:event_okButtonActionPerformed

    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        setVisible(false);
        dispose();
    }//GEN-LAST:event_closeDialog

    /**
    * @param args the command line arguments
    */
    public static void main(String args[]) {
        new AboutDialog(new javax.swing.JFrame(), false).show();
    }

    public void setAboutTab(String s)
    {
        this.titleAbout = s;
    }

    public void setLicenseTab(String s)
    {
       this.titleLicense = s;
    }

    public void setLicense(String s)
    {
        this.license=s;
    }

    public void setThanks(String s)
    {
        this.thanks=s;
    }

    public void setIcon(ImageIcon icon)
    {
        this.icon=icon;
    }

    public void setThanksTab(String s)
    {
        this.titleThanks=s;
    }

    public void create()
    {
        initComponents();
        myTabbedPane.setTitleAt(0,titleAbout);
        myTabbedPane.setTitleAt(1,titleLicense);
        myTabbedPane.setTitleAt(2,titleThanks);
        licenseEditorPane.setCaretPosition(0);
        thanksEditorPane.setCaretPosition(0);
    }


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel mainPanel;
    private javax.swing.JTabbedPane myTabbedPane;
    private javax.swing.JPanel aboutPanel;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JLabel imageLabel;
    private javax.swing.JPanel licensePanel;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JEditorPane licenseEditorPane;
    private javax.swing.JPanel thanksPanel;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JEditorPane thanksEditorPane;
    private javax.swing.JPanel okPanel;
    private javax.swing.JButton okButton;
    // End of variables declaration//GEN-END:variables

    private ImageIcon icon;
    private String license;
    private String titleLicense;
    private String titleAbout;
    private String titleThanks;
    private String thanks;


}
