/******************************************************************************
 *
 * Sugar for Java 1.2.0
 * Copyright (C) 2001-2004  Dipl.-Inf. (FH) Johann Nepomuk Loefflmann,
 * All Rights Reserved, http://www.jonelo.de
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * @author jonelo@jonelo.de
 *
 *
 *****************************************************************************/

package jonelo.sugar.math;


public class GeneralMath {

  public static String decimal2Scientific(String str) {
     StringBuffer sb = new StringBuffer(str);
     boolean signflag=false;

     char sign=sb.charAt(0);
     if ((sign=='-') || (sign=='+')) {
        signflag=true;
        sb.deleteCharAt(0);
     }

     // remove leading zeros
     while ((sb.length() > 0) && (sb.charAt(0)=='0')) {
       sb.deleteCharAt(0);
     }
     if (sb.length()== 0) sb.append("0");

     // remove dot
     // where is the decimal point?
     // or in other words:
     // what's the exponent?
     int point = sb.indexOf(".");
     if (point == -1) point=sb.length();
     else sb.deleteCharAt(point);

     while ((sb.length() > 1) && (sb.charAt(0)=='0')) {
       sb.deleteCharAt(0);
       point--;
     }


     // remove tailing zeros
     while ((sb.length() > 1) && (sb.charAt(sb.length()-1)=='0')) {
         sb.deleteCharAt(sb.length()-1);
     }

     // add decimalpoint
     sb.insert(1,'.');
     sb.append('e');
     sb.append(Integer.toString(point-1));

     // add sign
     if (signflag) sb.insert(0,sign);
     return sb.toString();
  }


}
